-- sr2_city.lua
-- Master Lua Script for Saints Row 2
-- 3/28/07

-- Sandbox++ Options [nclok1405]

-- Enable cops shooting from vehicle by default
SPP_OPTIONS_COP_DRIVEBY = true
-- Show lightcone for CD Finder
SPP_OPTIONS_SHOW_LIGHTCONE_FOR_CD_FINDER = true

--[[

How the new key sequences work in-game:

The player presses 888 which displays a message on the HUD that it is ready for input (a 3 digit code)
The player then enters a 3 digit code and presto change-o it will run whatever commands are there for the section
of the conditional block that resolves. If it fails to resolve, it will show a message on the HUD that it failed
and reset the input sequence so the user has to start again with 111 and then his 3 digit code.

Yes, the code is a bit messy. But it's the only way I could think of to make it work with player_button_just_pressed()
which seems to be the only function that's available to capture input in the open world. I would much rather have done
a toggle/pivot like the SRTT Sandbox+ but we're kind of stuck with a sequenced code (at least for now.) -IdolNinja

]]

-- New thread to grab keyboard input for Sandbox+
Keycombo_Handle = INVALID_THREAD_HANDLE

-- Key bind variables
PC_BTN_MOVE_UP = 0
PC_BTN_MOVE_DOWN = 1
PC_BTN_MOVE_LEFT = 2
PC_BTN_MOVE_RIGHT = 3
PC_BTN_ACTION = 4
PC_BTN_JUMP = 5
PC_BTN_RADIAL = 6
PC_BTN_BREAK = 7
PC_DPAD_RIGHT = 8
PC_DPAD_UP = 9
PC_DPAD_LEFT = 10
PC_DPAD_DOWN = 11
PC_BTN_START = 12
PC_BTN_BACK = 13
PC_BTN_RELOAD = 14
PC_BTN_CROUCH = 15
PC_BTN_FINE_AIM = 16
PC_BTN_GRAB_HUMAN = 17
PC_BTN_SPRINT = 18
PC_BTN_BLOCK = 19
PC_BTN_MAP = 20
PC_BTN_PAUSE = 21
PC_BTN_HORN = 26
PC_BTN_CRUISE = 27
PC_BTN_RESET_CAMERA = 28
PC_BTN_RADIO_PREV = 29
PC_BTN_RADIO_NEXT = 30
PC_BTN_LOOK_RIGHT = 31
PC_BTN_LOOK_LEFT = 32
PC_WPN_SWITCH_UP = 33
PC_WPN_SWITCH_DOWN = 34
PC_BTN_ATTACK = 35
PC_BTN_ATTACK2 = 36
PC_BTN_ACCELERATE = 37
PC_BTN_REVERSE = 38
PC_BTN_SELECT_WEAPON_1 = 39
PC_BTN_SELECT_WEAPON_2 = 40
PC_BTN_SELECT_WEAPON_3 = 41
PC_BTN_SELECT_WEAPON_4 = 42
PC_BTN_SELECT_WEAPON_5 = 43
PC_BTN_SELECT_WEAPON_6 = 44
PC_BTN_SELECT_WEAPON_7 = 45
PC_BTN_SELECT_WEAPON_8 = 46
PC_BTN_HELI_TURN_LEFT = 47
PC_BTN_HELI_TURN_RIGHT = 48
PC_BTN_VEHICLE_LOOK_BEHIND = 49
PC_BTN_AIR_ACCELERATE = 50
PC_BTN_AIR_DECELERATE = 51
PC_BTN_RECRUIT = 52
PC_BTN_CANCEL = 53
PC_BTN_TAUNT = 54
PC_BTN_COMPLIMENT = 55
PC_BTN_HYDRAULICS = 56
PC_BTN_NITRO = 57
PC_BTN_FIGHT_CLUB_MASH_1 = 58
PC_BTN_FIGHT_CLUB_MASH_2 = 59
PC_BTN_FIGHT_CLUB_MASH_3 = 60
PC_BTN_FIGHT_CLUB_MASH_4 = 61
PC_BTN_PAD_MENU_SELECT = 62
PC_BTN_WALK = 63
PC_BTN_MOTO_PITCH_UP = 64
PC_BTN_MOTO_PITCH_DOWN = 65
PC_BTN_ZOOM_IN = 66
PC_BTN_ZOOM_OUT = 67
PC_BTN_MENU_SCROLL_LEFT = 68
PC_BTN_MENU_SCROLL_RIGHT = 69
PC_BTN_MENU_DPAD_UP = 70
PC_BTN_MENU_DPAD_DOWN = 71
PC_BTN_MENU_DPAD_LEFT = 72
PC_BTN_MENU_DPAD_RIGHT = 73
PC_BTN_MENU_ALT_SELECT = 74
PC_BTN_X = 75
PC_BTN_PAD_BACK = 76
PC_PAD_DPAD_RIGHT = 77
PC_PAD_DPAD_UP = 78
PC_PAD_DPAD_LEFT = 79
PC_PAD_DPAD_DOWN = 80
PC_BTN_PAD_START = 81
PC_BTN_PAD_LS_PRESS = 82
PC_BTN_PAD_RS_PRESS = 83
PC_BTN_CHAT_ALL = 84
PC_BTN_CHAT_TEAM = 85


-- input code entry variables
CODEONE = false
CODETWO = false
CODETHREE = false
INPUT_CODE_ONE = false
INPUT_CODE_TWO = false
INPUT_CODE_THREE = false
codestring = ""
INPUT_CODE_READY = false

-- Zone State variables
Riot_State = true
Ship_State = true
Hospital_State = true
Festival_State = true
Yacht_State = true
Burning_State = true
Barn_State = true

--Special Command vars
COOP_COMMANDS_ACTIVE = false
SANDBOX_MESSAGES = true
WEAPON_SWAP_DISABLED = false

--Sandbox++ Variables [nclok1405]
SPP_COP_DRIVEBY = false			-- Cop Driveby
SPP_SPAWNING_PEDS = 0		-- Spawn peds
SPP_SPAWNING_ACTION_NODE_PEDS = true	-- Spawn non-walking civilians
SPP_SPAWNING_VEHICLES = true		-- Spawn vehicles
SPP_ENABLE_TRAFFIC = 0		-- Enable civilian traffic
SPP_ENABLE_AMBIENT_COP_SPAWNS = true	-- Enable ambient cops
SPP_ENABLE_AMBIENT_GANG_SPAWNS = true	-- Enable ambient gangs
SPP_ENABLE_ROADBLOCKS = true		-- Enable roadblocks
SPP_PED_BUMS = false			-- Spawn Bum Peds
SPP_INDOOR_GANG = false			-- Enable indoor notoriety gang spawns
SPP_RESTRICTED_ZONES = true		-- Notoriety for restricted zones
SPP_ENABLE_BOATS = true			-- Enable boats
SPP_CD_FINDER = false			-- CD Finder
SPP_HEALTH_REGEN = true			-- Enable health regeneration
SPP_FORCE_PASSENGER_SEAT = false	-- Force passenger seat
SPP_INVERTED_SONG_OF_TIME = 0	-- Time Speed
SPP_HOUR = 0	-- Hour
SPP_WEATHER = 0	-- Weather
SPP_RAGDOLL = true	-- Player Ragdoll
SPP_VEHICLE_ENTER_EXIT = true -- Allow Vehicle Enter/Exit
SPP_VEHICLE_INFINITE_MASS = true	-- Infinite Mass
SPP_VEHICLE_SUPPRESS_FLIPPING = true	-- Suppress Vehicle Flipping

SPP_SAINTS_HQ_LEVEL = 0	-- Saints HQ status
SPP_PHILLIPS_BUILDING = true	-- Phillips Building status

Spp_stink_thread_handle = INVALID_THREAD_HANDLE	-- Peds run away thread
Spp_auto_repair_thread_handle = INVALID_THREAD_HANDLE	-- Auto Vehicle Repair thread

Spp_last_command_code = "None"	-- Last activated code number
Spp_last_command_text = ""	-- Last activated code description

-- VANILLA STUFF
include("airport.lua")					-- DISTRICTS
include("apartments.lua")
include("arena.lua")
include("barrio.lua")
include("chinatown.lua")
include("docks.lua")
include("downtown.lua")
include("factories.lua")
include("highend.lua")
include("hotels.lua")
include("museum.lua")
include("nuke.lua")
include("prison.lua")
include("projects.lua")
include("redlight.lua")
include("saintsrow.lua")
include("suburbs.lua")
include("subexp.lua")
include("trailerpark.lua")
include("truckyard.lua")
include("ultor_base.lua")
include("underground.lua")
include("university.lua")

include("mission_globals.lua")		-- MISSIONS
include("stronghold_globals.lua")	-- STRONGHOLDS

-- Get player sync constant [nclok1405]
function sandbox_get_sync(player)
	local sync = SYNC_ALL
	if (player == LOCAL_PLAYER) or (player == SYNC_LOCAL) then
		sync = SYNC_LOCAL
	elseif (player == REMOTE_PLAYER) or (player == SYNC_REMOTE) then
		sync = SYNC_REMOTE
	end
	return sync
end

function reset_input_sequence()
	--debug_print("RESET INPUT SEQUENCE")
	CODEONE = false
	CODETWO = false
	CODETHREE = false
	INPUT_CODE_ONE = false
	INPUT_CODE_TWO = false
	INPUT_CODE_THREE = false
	codestring = ""
	INPUT_CODE_READY = false
end

function input_code_one_activated()
	INPUT_CODE_ONE = true
	debug_print("CODESTRING: "..codestring)
	--mission_help_table("CODESTRING: "..codestring, LOCAL_PLAYER)

	if SANDBOX_MESSAGES and CODETHREE then
		mission_help_clear(SYNC_LOCAL)
		mission_help_table_nag(codestring.."**", "", "", SYNC_LOCAL)
	end
end

function input_code_two_activated()
	INPUT_CODE_TWO = true
	debug_print("CODESTRING: "..codestring)
	--mission_help_table("CODESTRING: "..codestring, LOCAL_PLAYER)

	if SANDBOX_MESSAGES and CODETHREE then
		mission_help_clear(SYNC_LOCAL)
		mission_help_table_nag(codestring.."*", "", "", SYNC_LOCAL)
	end
end

function input_code_three_activated()
	INPUT_CODE_THREE = true
	INPUT_CODE_READY = true
	debug_print("CODESTRING: "..codestring)
	--mission_help_table("CODESTRING: "..codestring, LOCAL_PLAYER)
end


function sandbox_message(text,player)
	if SANDBOX_MESSAGES == true then
		--objective_text_clear(0)
		--mission_help_table("CODE ENTRY: "..codestring.."\n"..text, player)
		Spp_last_command_code = codestring
		Spp_last_command_text = text

		local msg = "CODE ENTRY: "..codestring.."\n"..text
		local sync = sandbox_get_sync(player)

		mission_help_clear(sync)
		mission_help_table_nag(msg, "", "", sync)
	end
end

-- Change player's outfit [nclok1405]
function spp_outfit_wear(outfit_name, display_name)
	if (display_name == nil) then
		display_name = outfit_name
	end

	customization_outfit_wear( outfit_name, 0, SYNC_LOCAL )
	customization_item_revert(SYNC_LOCAL)	-- Re-enable access to wardrobe, which will restore the player's original outfit
	if COOP_COMMANDS_ACTIVE then
		customization_outfit_wear( outfit_name, 0, SYNC_REMOTE )
		customization_item_revert(SYNC_REMOTE)
	end

	sandbox_message("Outfit changed to "..display_name)
	reset_input_sequence()
end

-- A thread that makes nearby peds run away [nclok1405]
function spp_stink_thread()
	while true do
		character_set_all_civilians_fleeing(LOCAL_PLAYER, 50)
		
		if COOP_COMMANDS_ACTIVE then
			character_set_all_civilians_fleeing(REMOTE_PLAYER, 50)
		end
		
		thread_yield()	-- Let other threads run (the game freezes otherwise)
		-- This thread is killed here when thread_kill is used
	end
end

-- A thread that constantly repairs player's vehicle [nclok1405]
function spp_auto_repair_thread()
	while true do
		local player_vehicle, partner_vehicle = spp_get_player_vehicle_names()
		
		if player_vehicle ~= "" then
			vehicle_repair(player_vehicle)
		end
		if partner_vehicle ~= "" then
			vehicle_repair(partner_vehicle)
		end
		
		thread_yield()	-- Let other threads run (the game freezes otherwise)
	end
end

-- Teleport to specified location [nclok1405]
-- navpoint_name: Navpoint
-- location_name: (optional) Location Name displayed to the player
function spp_teleport(navpoint_name, location_name)
	teleport(LOCAL_PLAYER, navpoint_name)
	if COOP_COMMANDS_ACTIVE then
		teleport(REMOTE_PLAYER, navpoint_name)
	end
	if (location_name ~= nil) and (location_name ~= "") then
		-- Set which player to show the message
		local sync = SYNC_ALL
		if not COOP_COMMANDS_ACTIVE then
			sync = SYNC_LOCAL
		end
		sandbox_message("Teleported to "..location_name, sync)
	end
end

-- Play keypad sound [nclok1405]
function spp_play_keypad_sound(num)
	if not SANDBOX_MESSAGES then
		return
	end
	audio_play("SYS_CELL_"..tostring(num))
end

-- Get Player Vehicle Names [nclok1405]
function spp_get_player_vehicle_names()
	local player_vehicle = get_char_vehicle_name(LOCAL_PLAYER)
	local partner_vehicle = ""
	if COOP_COMMANDS_ACTIVE then
		partner_vehicle = get_char_vehicle_name(REMOTE_PLAYER)
	end
	return player_vehicle, partner_vehicle
end

function keycombo_thread()
	while (1) do
		-- If the co-op parner quits, reset the co-op flag [nclok1405]
		if not coop_is_active() then
			COOP_COMMANDS_ACTIVE = false
		end
		
		-- Reset everything if normal keys other than 888 are hit. This cancels the sequence
		if player_button_just_pressed(PC_BTN_ATTACK) or player_button_just_pressed(PC_BTN_SPRINT) or player_button_just_pressed(PC_BTN_ACTION) or player_button_just_pressed(PC_BTN_MOVE_UP) then 
			-- Cancel Message
			if SANDBOX_MESSAGES and CODETHREE then
				audio_play("SYS_MENU_BACK")	-- Play "Back" sound
				mission_help_clear(SYNC_LOCAL)
				mission_help_table_nag("CODE ENTRY CANCELLED", "", "", SYNC_LOCAL)
			end
			reset_input_sequence()
		end


		if player_button_just_pressed(PC_BTN_SELECT_WEAPON_8) and CODEONE == false and CODETWO == false and CODETHREE == false then
			CODEONE = true
			debug_print("CODEONE READY")
		elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_8) and CODEONE == true and CODETWO == false and CODETHREE == false then
			CODETWO = true
			debug_print("CODETWO READY")
		elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_8) and CODEONE == true and CODETWO == true and CODETHREE == false then
			CODETHREE = true
			debug_print("CODETHREE READY")
			if SANDBOX_MESSAGES then
				audio_play("SYS_OBJECTIVE_COMPLETE")	-- Play "Ding" sound
				mission_help_table_nag("READY FOR CODE ENTRY", "", "", SYNC_LOCAL)
			end
		elseif CODETHREE == true and INPUT_CODE_ONE == false then
			if player_button_just_pressed(PC_BTN_SELECT_WEAPON_1) and CODETHREE == true then
				spp_play_keypad_sound(1)
				codestring = (codestring.."1")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_2) and CODETHREE == true then
				spp_play_keypad_sound(2)
				codestring = (codestring.."2")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_3) and CODETHREE == true then
				spp_play_keypad_sound(3)
				codestring = (codestring.."3")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_4) and CODETHREE == true then
				spp_play_keypad_sound(4)
				codestring = (codestring.."4")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_5) and CODETHREE == true then
				spp_play_keypad_sound(5)
				codestring = (codestring.."5")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_6) and CODETHREE == true then
				spp_play_keypad_sound(6)
				codestring = (codestring.."6")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_7) and CODETHREE == true then
				spp_play_keypad_sound(7)
				codestring = (codestring.."7")
				input_code_one_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_8) and CODETHREE == true then
				spp_play_keypad_sound(8)
				codestring = (codestring.."8")
				input_code_one_activated()
			end
		elseif INPUT_CODE_ONE == true and INPUT_CODE_TWO == false then
			if player_button_just_pressed(PC_BTN_SELECT_WEAPON_1) and CODETHREE == true then
				spp_play_keypad_sound(1)
				codestring = (codestring.."1")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_2) and CODETHREE == true then
				spp_play_keypad_sound(2)
				codestring = (codestring.."2")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_3) and CODETHREE == true then
				spp_play_keypad_sound(3)
				codestring = (codestring.."3")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_4) and CODETHREE == true then
				spp_play_keypad_sound(4)
				codestring = (codestring.."4")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_5) and CODETHREE == true then
				spp_play_keypad_sound(5)
				codestring = (codestring.."5")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_6) and CODETHREE == true then
				spp_play_keypad_sound(6)
				codestring = (codestring.."6")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_7) and CODETHREE == true then
				spp_play_keypad_sound(7)
				codestring = (codestring.."7")
				input_code_two_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_8) and CODETHREE == true then
				spp_play_keypad_sound(8)
				codestring = (codestring.."8")
				input_code_two_activated()
			end
		elseif INPUT_CODE_TWO == true and INPUT_CODE_THREE == false then
			if player_button_just_pressed(PC_BTN_SELECT_WEAPON_1) and CODETHREE == true then
				spp_play_keypad_sound(1)
				codestring = (codestring.."1")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_2) and CODETHREE == true then
				spp_play_keypad_sound(2)
				codestring = (codestring.."2")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_3) and CODETHREE == true then
				spp_play_keypad_sound(3)
				codestring = (codestring.."3")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_4) and CODETHREE == true then
				spp_play_keypad_sound(4)
				codestring = (codestring.."4")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_5) and CODETHREE == true then
				spp_play_keypad_sound(5)
				codestring = (codestring.."5")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_6) and CODETHREE == true then
				spp_play_keypad_sound(6)
				codestring = (codestring.."6")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_7) and CODETHREE == true then
				spp_play_keypad_sound(7)
				codestring = (codestring.."7")
				input_code_three_activated()
			elseif player_button_just_pressed(PC_BTN_SELECT_WEAPON_8) and CODETHREE == true then
				spp_play_keypad_sound(8)
				codestring = (codestring.."8")
				input_code_three_activated()
			end
		end

		if INPUT_CODE_READY == true then
			if codestring == "111" then
				spp_teleport("airport_$nav-warp", "Airport")
				reset_input_sequence()
			elseif codestring == "112" then
				spp_teleport("apartments_$nav-warp", "Apartments")
				reset_input_sequence()
			elseif codestring == "113" then
				spp_teleport("arena_$nav-warp", "Arena")
				reset_input_sequence()
			elseif codestring == "114" then
				spp_teleport("barrio_$nav-warp", "Barrio")
				reset_input_sequence()
			elseif codestring == "115" then
				spp_teleport("chinatown_$nav-warp", "Chinatown")
				reset_input_sequence()
			elseif codestring == "116" then
				spp_teleport("docks_$nav-warp", "Docks & Warehouses")
				reset_input_sequence()
			elseif codestring == "117" then
				spp_teleport("downtown_$nav-warp", "Downtown")
				reset_input_sequence()
			elseif codestring == "118" then
				spp_teleport("factories_$nav-warp", "Factories")
				reset_input_sequence()
			elseif codestring == "121" then
				spp_teleport("highend_$nav-warp", "High End Retail")
				reset_input_sequence()
			elseif codestring == "122" then
				spp_teleport("hotels_$nav-warp", "Hotels & Marina")
				reset_input_sequence()
			elseif codestring == "123" then
				spp_teleport("museum_$nav-warp", "Museum")
				reset_input_sequence()
			elseif codestring == "124" then
				spp_teleport("nuke_$nav-warp", "Nuclear Power Plant")
				reset_input_sequence()
			elseif codestring == "125" then
				spp_teleport("prison_$nav-warp", "Stilwater Prison")
				reset_input_sequence()
			elseif codestring == "126" then
				spp_teleport("projects_$nav-warp", "Projects")
				reset_input_sequence()
			elseif codestring == "127" then
				spp_teleport("redlight_$nav-warp", "Red Light")
				reset_input_sequence()
			elseif codestring == "128" then
				spp_teleport("saintsrow_$nav-warp", "Saint's Row")
				reset_input_sequence()
			elseif codestring == "131" then
				spp_teleport("suburbs_$nav-warp", "Suburbs")
				reset_input_sequence()
			elseif codestring == "132" then
				spp_teleport("subexp_$nav-warp", "Suburbs Expansion")
				reset_input_sequence()
			elseif codestring == "133" then
				spp_teleport("trailerpark_$nav-warp", "Trailer Park")
				reset_input_sequence()
			elseif codestring == "134" then
				spp_teleport("truckyard_$nav-warp", "Truck Yard")
				reset_input_sequence()
			elseif codestring == "135" then
				spp_teleport("university_$nav-warp", "Stilwater University")
				reset_input_sequence()
			elseif codestring == "136" then
				spp_teleport("sr2_city_$sh_tss_ugmall", "Rounds Square Shopping Center")
				reset_input_sequence()
			elseif codestring == "137" then
				spp_teleport("sr2_city_$sh_tss_caverns", "Stilwater Caverns Entrance")
				reset_input_sequence()
			elseif codestring == "138" then
				spp_teleport("ultor_base_$i000", "The Pyramid")
				reset_input_sequence()


			elseif codestring == "141" then
				spp_teleport("cribs_sr2_city_$HE_crib_clothing", "Penthouse Loft")
				reset_input_sequence()
			elseif codestring == "142" then
				spp_teleport("cribs_sr2_city_$PI_crib_clothes", "Prison Lighthouse")
				reset_input_sequence()
			elseif codestring == "143" then
				spp_teleport("cribs_sr2_city_$SR_crib_clothes", "Saints Row Mega Condo")
				reset_input_sequence()
			elseif codestring == "144" then
				spp_teleport("cribs_sr2_city_$RL_crib_clothes", "Red Light Loft")
				reset_input_sequence()
			elseif codestring == "145" then
				spp_teleport("cribs_sr2_city_$SU_crib_clothes", "University Loft")
				reset_input_sequence()
			elseif codestring == "146" then
				spp_teleport("cribs_sr2_city_$SHQ_clothes", "Saints Hideout")
				reset_input_sequence()
			elseif codestring == "147" then
				spp_teleport("cribs_sr2_city_$DT_crib_clothes", "Downtown Loft")
				reset_input_sequence()
			elseif codestring == "148" then
				spp_teleport("cribs_sr2_city_$AI_wardrobe", "Hotel Penthouse")
				reset_input_sequence()
			elseif codestring == "151" then
				spp_teleport("cribs_sr2_city_$AI_Hangar", "Airport Hangar")
				reset_input_sequence()
			elseif codestring == "152" then
				spp_teleport("cribs_sr2_city_$SU_Dock", "University Dock")
				reset_input_sequence()
			elseif codestring == "153" then
				spp_teleport("cribs_sr2_city_$SB_Dock", "Suburbs Dock")
				reset_input_sequence()
			elseif codestring == "154" then
				spp_teleport("cribs_sr2_city_$SB_Aisha_clothes", "Aisha's House")
				reset_input_sequence()
			elseif codestring == "155" then
				spp_teleport("cribs_sr2_city_$YT_ultor_clothes", "Ultor Yacht")
				reset_input_sequence()
			elseif codestring == "156" then
				spp_teleport("cribs_sr2_city_$PB_clothes", "Phillips Building")
				reset_input_sequence()

			elseif codestring == "158" then
				spp_teleport("hoing_suburbs1", "Ho-ing Technically Legal")
				reset_input_sequence()
			elseif codestring == "161" then
				spp_teleport("activity_start_sr2_city_mayhem_nu", "Mayhem Nuclear Plant (Before/After Completion)")
				reset_input_sequence()
			elseif codestring == "162" then
				spp_teleport("activity_start_sr2_city_mayhem_nu_alternate", "Mayhem Nuclear Plant (In-Progress marker in Apartments)")
				reset_input_sequence()
			elseif codestring == "163" then
				spp_teleport("activity_start_sr2_city_mayhem_st", "Mayhem Red Light")
				reset_input_sequence()
			elseif codestring == "164" then
				spp_teleport("activity_start_sr2_city_demoderby_un", "Demolition Derby")
				reset_input_sequence()
			elseif codestring == "165" then
				spp_teleport("activity_start_sr2_city_crowd_ht", "Crowd Control Hotels & Marina")
				reset_input_sequence()
			elseif codestring == "166" then
				spp_teleport("activity_start_sr2_city_crowd_su", "Crowd Control Suburbs")
				reset_input_sequence()
			elseif codestring == "167" then
				spp_teleport("activity_start_sr2_city_drug_ai", "Drug Trafficking Airport")
				reset_input_sequence()
			elseif codestring == "168" then
				spp_teleport("activity_start_sr2_city_drug_ht", "Drug Trafficking Hotels & Marina")
				reset_input_sequence()
			elseif codestring == "171" then
				spp_teleport("activity_start_sr2_city_escort_un", "Escort Stilwater University")
				reset_input_sequence()
			elseif codestring == "172" then
				spp_teleport("activity_start_sr2_city_escort_rl", "Escort Red Light")
				reset_input_sequence()
			elseif codestring == "173" then
				spp_teleport("activity_start_sr2_city_fight_pr", "Fight Club Prison")
				reset_input_sequence()
			elseif codestring == "174" then
				spp_teleport("activity_start_sr2_city_fight_ar", "Fight Club Arena")
				reset_input_sequence()
			elseif codestring == "175" then
				spp_teleport("activity_start_sr2_city_fuzz_sx", "FUZZ Suburbs")
				reset_input_sequence()
			elseif codestring == "176" then
				spp_teleport("activity_start_sr2_city_fuzz_pj", "FUZZ Projects")
				reset_input_sequence()
			elseif codestring == "177" then
				spp_teleport("activity_start_sr2_city_heli_tp", "Heli Assault Trailer Park")
				reset_input_sequence()
			elseif codestring == "178" then
				spp_teleport("activity_start_sr2_city_heli_br", "Heli Assault Barrio")
				reset_input_sequence()
			elseif codestring == "181" then
				spp_teleport("activity_start_sr2_city_fraud_fc", "Insurance Fraud Factory")
				reset_input_sequence()
			elseif codestring == "182" then
				spp_teleport("activity_start_sr2_city_fraud_mu", "Insurance Fraud Museum")
				reset_input_sequence()
			elseif codestring == "183" then
				spp_teleport("activity_start_sr2_city_sewage_sx", "Septic Avenger Suburbs")
				reset_input_sequence()
			elseif codestring == "184" then
				spp_teleport("activity_start_sr2_city_sewage_rl", "Septic Avenger Red Light")
				reset_input_sequence()
			elseif codestring == "185" then
				spp_teleport("activity_start_sr2_city_snatch_ct", "Snatch Chinatown")
				reset_input_sequence()
			elseif codestring == "186" then
				spp_teleport("activity_start_sr2_city_snatch_dt", "Snatch Downtown")
				reset_input_sequence()
			elseif codestring == "187" then
				spp_teleport("activity_start_sr2_city_torch_dt", "Trail Blazing Downtown")
				reset_input_sequence()
			elseif codestring == "188" then
				spp_teleport("activity_start_sr2_city_torch_ap", "Trail Blazing Apartments")
				reset_input_sequence()


			elseif codestring == "211" then
				if Riot_State then
					city_chunk_swap( "sr2_intsrmisprison02", "riot", true, true, false )
					sandbox_message("Prison Riot swapped in", LOCAL_PLAYER)
				else
					city_chunk_swap( "sr2_intsrmisprison02", "normal", true, true, false )
					sandbox_message("Prison returned to normal", LOCAL_PLAYER)
				end
				Riot_State = not Riot_State
				reset_input_sequence()
			elseif codestring == "212" then
				if Ship_State then
					city_chunk_swap("sr2_chunk012", "ship", false, true, false )
					sandbox_message("Brotherhood tanker swapped in", LOCAL_PLAYER)
				else
					city_chunk_swap("sr2_chunk012", "normal", false, true, false )
					sandbox_message("Brotherhood tanker removed", LOCAL_PLAYER)
				end
				Ship_State = not Ship_State
				reset_input_sequence()
			elseif codestring == "213" then
				if Festival_State then
					city_chunk_swap("sr2_chunk179", "festival", false, true, false)
					city_chunk_swap("sr2_intmamis3junksempty", "festival", true, true, false)
					sandbox_message("Heritage Festival swapped in", LOCAL_PLAYER)
				else
					city_chunk_swap("sr2_chunk179", "normal", false, true, false)
					city_chunk_swap("sr2_intmamis3junksempty", "normal", true, true, false)

					sandbox_message("Heritage Festival removed", LOCAL_PLAYER)
				end
				Festival_State = not Festival_State
				reset_input_sequence()
			elseif codestring == "214" then
				if Yacht_State then
					city_chunk_swap("sr2_chunk111", "yacht", false, true, false )
					city_chunk_swap("sr2_intsrmisyacht01empty", "yacht", true, true, false )
					sandbox_message("Ultor Yacht swapped in", LOCAL_PLAYER)
				else
					city_chunk_swap("sr2_chunk111", "normal", false, true, false )
					city_chunk_swap("sr2_intsrmisyacht01empty", "normal", true, true, false )
					sandbox_message("Ultor Yacht removed", LOCAL_PLAYER)
				end
				Yacht_State = not Yacht_State
				reset_input_sequence()
			elseif codestring == "215" then
				if Burning_State then
					--city_chunk_swap("sr2_intprmismethlab01", "burned", true, true, false )
					--city_chunk_swap("sr2_intprmismethlab03", "Burned", true, true, false )
					--city_chunk_swap("sr2_intprmismethlab04", "Burned", true, true, false )
					city_chunk_swap("sr2_chunk093", "Burned", true, true, false )
					city_chunk_swap("sr2_chunk104", "Burned", true, true, false )
					sandbox_message("Projects and meth labs burning", LOCAL_PLAYER)
				else
					--city_chunk_swap("sr2_intprmismethlab01", "normal", true, true, false )
					--city_chunk_swap("sr2_intprmismethlab03", "normal", true, true, false )
					--city_chunk_swap("sr2_intprmismethlab04", "normal", true, true, false )
					city_chunk_swap("sr2_chunk093", "normal", true, true, false )
					city_chunk_swap("sr2_chunk104", "normal", true, true, false )
					sandbox_message("Projects returned to normal", LOCAL_PLAYER)
				end
				Burning_State = not Burning_State
				reset_input_sequence()
			elseif codestring == "216" then
				if Hospital_State then
					city_chunk_swap("SR2_IntDTMisHospital", "blackout", true, true, false)
					city_chunk_swap("SR2_IntDTMisHospital02", "blackout", false, true, false)
					city_chunk_swap("SR2_IntDTMisHospital03", "blackout", true, true, false)
					sandbox_message("Hospital now in blackout", LOCAL_PLAYER)
				else
					city_chunk_swap("SR2_IntDTMisHospital", "normal", true, true, false)
					city_chunk_swap("SR2_IntDTMisHospital02", "normal", false, true, false)
					city_chunk_swap("SR2_IntDTMisHospital03", "normal", true, true, false)
					sandbox_message("Hospital returned to normal", LOCAL_PLAYER)
				end
				Hospital_State = not Hospital_State
				reset_input_sequence()
			elseif codestring == "217" then
				if Barn_State then
					city_chunk_swap("sr2_chunk128", "destroyable_barn", false, true, false )
					sandbox_message("Samedi drug farm barn now destroyed", LOCAL_PLAYER)
				else
					city_chunk_swap("sr2_chunk128", "normal", false, true, false )
					sandbox_message("Samedi drug farm barn now intact", LOCAL_PLAYER)
				end
				Barn_State = not Barn_State
				reset_input_sequence()
			elseif codestring == "218" then
				-- Saints Hideout Status [nclok1405]
				-- interior = false, blocking = true, temporary = false
				if SPP_SAINTS_HQ_LEVEL == 0 then
					city_chunk_swap("sr2_ug_chunk104_ST_HQ", "level1", false, true, false)
					sandbox_message("Saints Hideout set to Level 1")
					SPP_SAINTS_HQ_LEVEL = 1
				elseif SPP_SAINTS_HQ_LEVEL == 1 then
					city_chunk_swap("sr2_ug_chunk104_ST_HQ", "level2", false, true, false)
					sandbox_message("Saints Hideout set to Level 2")
					SPP_SAINTS_HQ_LEVEL = 2
				elseif SPP_SAINTS_HQ_LEVEL == 2 then
					city_chunk_swap("sr2_ug_chunk104_ST_HQ", "level3", false, true, false)
					sandbox_message("Saints Hideout set to Level 3")
					SPP_SAINTS_HQ_LEVEL = 0
				end
				reset_input_sequence()

			elseif codestring == "221" then
				spp_teleport("garage_sr2_city_$TY_semi_store", "Semi Broken")
				reset_input_sequence()
			elseif codestring == "222" then
				spp_teleport("garage_sr2_city_$NU_mech_store", "Rim Jobs Nuclear Power Plant")
				reset_input_sequence()
			elseif codestring == "223" then
				spp_teleport("shops_sr2_city_$SX_plas_store", "Image as Designed Suburbs Expansion")
				reset_input_sequence()
			elseif codestring == "224" then
				spp_teleport("shops_sr2_city_$HER_plas_store", "Image as Designed Suburbs")
				reset_input_sequence()
			elseif codestring == "225" then
				spp_teleport("shops_sr2_city_$DT_plas_store", "Image as Designed Downtown")
				reset_input_sequence()
			elseif codestring == "226" then
				spp_teleport("shops_sr2_city_$SR_plas_store", "Image as Designed Saint's Row")
				reset_input_sequence()
			elseif codestring == "227" then
				spp_teleport("shops_sr2_city_$SU_gun_store", "Friendly Fire Suburbs")
				reset_input_sequence()
			elseif codestring == "228" then
				spp_teleport("shops_sr2_city_$AP_gun_store", "Friendly Fire Apartments")
				reset_input_sequence()
			elseif codestring == "231" then
				spp_teleport("shops_sr2_city_$DK_gun_store", "Friendly Fire Docks & Warehouses")
				reset_input_sequence()
			elseif codestring == "232" then
				spp_teleport("shops_sr2_city_$DT_gun_store", "Friendly Fire Downtown")
				reset_input_sequence()
			elseif codestring == "233" then
				spp_teleport("shops_sr2_city_$MA_gun_store", "Friendly Fire RSSC")
				reset_input_sequence()
			elseif codestring == "234" then
				spp_teleport("shops_sr2_city_$BAR_brass_store", "Brass Knuckles Barrio")
				reset_input_sequence()
			elseif codestring == "235" then
				spp_teleport("shops_sr2_city_$MU_brass_store", "Brass Knuckles Museum")
				reset_input_sequence()
			elseif codestring == "236" then
				spp_teleport("shops_sr2_city_$MA_brass_store", "Brass Knuckles RSSC")
				reset_input_sequence()
			elseif codestring == "237" then
				spp_teleport("shops_sr2_city_$DT_brass_store", "Brass Knuckles Downtown")
				reset_input_sequence()
			elseif codestring == "238" then
				spp_teleport("shops_sr2_city_$SX_music_store", "Scratch That Suburbs Expansion")
				reset_input_sequence()
			elseif codestring == "241" then
				spp_teleport("shops_sr2_city_$UN_music_store", "Scratch That University")
				reset_input_sequence()
			elseif codestring == "242" then
				spp_teleport("shops_sr2_city_$BAR_music_store", "Scratch That Barrio")
				reset_input_sequence()
			elseif codestring == "243" then
				spp_teleport("shops_sr2_city_$SR_music_store", "Scratch That Saint's Row")
				reset_input_sequence()
			elseif codestring == "244" then
				spp_teleport("shops_sr2_city_$AP_music_store", "Scratch That Apartments")
				reset_input_sequence()
			elseif codestring == "245" then
				spp_teleport("shops_sr2_city_$SU_car", "Foreign Power Suburbs")
				reset_input_sequence()
			elseif codestring == "246" then
				spp_teleport("shops_sr2_city_$MU_car_store", "Foreign Power Museum")
				reset_input_sequence()
			elseif codestring == "247" then
				spp_teleport("shops_sr2_city_$SR_car_store", "Foreign Power Saint's Row")
				reset_input_sequence()
			elseif codestring == "248" then
				spp_teleport("shops_sr2_city_$AR_car_store", "Foreign Power Arena")
				reset_input_sequence()
			elseif codestring == "251" then
				spp_teleport("shops_sr2_city_$SU_bike", "Cycles Suburbs")
				reset_input_sequence()
			elseif codestring == "252" then
				spp_teleport("shops_sr2_city_$AR_bike_store", "Cycles Arena")
				reset_input_sequence()
			elseif codestring == "253" then
				spp_teleport("shops_sr2_city_$MU_bike_store", "Cycles Museum")
				reset_input_sequence()
			elseif codestring == "254" then
				spp_teleport("shops_sr2_city_$SU_boat", "Ship It Suburbs")
				reset_input_sequence()
			elseif codestring == "255" then
				spp_teleport("shops_sr2_city_$MAR_boat_store", "Ship It Hotels & Marina")
				reset_input_sequence()
			elseif codestring == "256" then
				spp_teleport("shops_sr2_city_$FCT_bluecollar_store", "Blue Collar Supply")
				reset_input_sequence()
			elseif codestring == "257" then
				spp_teleport("shops_sr2_city_$SR_impound_store", "S.P.D. Impound")
				reset_input_sequence()
			elseif codestring == "258" then
				spp_teleport("shops_sr2_city_$AIR_sparrow_store", "Sparrow Aircraft")
				reset_input_sequence()
			elseif codestring == "261" then
				spp_teleport("shops_sr2_city_$DK_scrapyard_store", "Stilwater Scrapyard")
				reset_input_sequence()
			elseif codestring == "262" then
				spp_teleport("shops_sr2_city_$MU_volition_store", "Volition Gift Shop")
				reset_input_sequence()
			elseif codestring == "263" then
				spp_teleport("shops_sr2_city_$SU_fb", "Freckle Bitch's Suburbs")
				reset_input_sequence()
			elseif codestring == "264" then
				spp_teleport("shops_sr2_city_$MU_fb_store", "Freckle Bitch's Museum")
				reset_input_sequence()
			elseif codestring == "265" then
				spp_teleport("shops_sr2_city_$AP_fb_store", "Freckle Bitch's Apartments")
				reset_input_sequence()
			elseif codestring == "266" then
				spp_teleport("shops_sr2_city_$BAR_fb_store", "Freckle Bitch's Barrio")
				reset_input_sequence()
			elseif codestring == "267" then
				spp_teleport("shops_sr2_city_$MA_freckle_store", "Freckle Bitch's RSSC")
				reset_input_sequence()
			elseif codestring == "268" then
				spp_teleport("shops_sr2_city_$AIR_hard_store", "Charred Hard Burgers Airport")
				reset_input_sequence()
			elseif codestring == "271" then
				spp_teleport("shops_sr2_city_$MAR_hard_store", "Charred Hard Burgers Hotels & Marina")
				reset_input_sequence()
			elseif codestring == "272" then
				spp_teleport("shops_sr2_city_$UN_hard_store", "Charred Hard Burgers University")
				reset_input_sequence()
			elseif codestring == "273" then
				spp_teleport("shops_sr2_city_$MU_hard_store", "Charred Hard Burgers Museum")
				reset_input_sequence()
			elseif codestring == "274" then
				spp_teleport("shops_sr2_city_$MA_appolo_store", "Apollo's RSSC")
				reset_input_sequence()
			elseif codestring == "275" then
				spp_teleport("shops_sr2_city_$DK_apollo_store", "Apollo's Docks & Warehouses")
				reset_input_sequence()
			elseif codestring == "276" then
				spp_teleport("shops_sr2_city_$AP_apollo_store", "Apollo's Apartments")
				reset_input_sequence()
			elseif codestring == "277" then
				spp_teleport("shops_sr2_city_$DT_apollo_store", "Apollo's Downtown")
				reset_input_sequence()
			elseif codestring == "278" then
				spp_teleport("shops_sr2_city_$MAR_phuc_store", "Phuc Mi Phuc Yue Hotels & Marina")
				reset_input_sequence()
			elseif codestring == "281" then
				spp_teleport("shops_sr2_city_$MA_phuc_store", "Phuc Mi Phuc Yue RSSC")
				reset_input_sequence()
			elseif codestring == "282" then
				spp_teleport("shops_sr2_city_$CT_phuc_store", "Phuc Mi Phuc Yue Chinatown")
				reset_input_sequence()
			elseif codestring == "283" then
				spp_teleport("shops_sr2_city_$MA_gyros_store", "Company of Gyros RSSC")
				reset_input_sequence()
			elseif codestring == "284" then
				spp_teleport("shops_sr2_city_$SU_gyros_store", "Company of Gyros Suburbs")
				reset_input_sequence()
			elseif codestring == "285" then
				spp_teleport("shops_sr2_city_$TY_liq_store", "Brown Baggers Truckyard")
				reset_input_sequence()
			elseif codestring == "286" then
				spp_teleport("shops_sr2_city_$MA_lace_store", "Leather & Lace")
				reset_input_sequence()
			elseif codestring == "287" then
				spp_teleport("shops_sr2_city_$MA_nobody_store", "Nobody Loves Me")
				reset_input_sequence()
			elseif codestring == "288" then
				spp_teleport("shops_sr2_city_$MA_pretend_store", "Let's Pretend")
				reset_input_sequence()


			elseif codestring == "311" then
				if notoriety_get("Samedi") == 5 then
					sandbox_message("Notoriety Sons of Samedi reset")
					notoriety_set("Samedi",0)
				else
					notoriety_set("Samedi",(notoriety_get("Samedi") +1))
					sandbox_message("Notoriety Sons of Samedi +1")
				end
				reset_input_sequence()
			elseif codestring == "312" then
				if notoriety_get("Ronin") == 5 then
					sandbox_message("Notoriety Ronin reset")
					notoriety_set("Ronin",0)
				else
					notoriety_set("Ronin",(notoriety_get("Ronin") +1))
					sandbox_message("Notoriety Ronin +1")
				end
				reset_input_sequence()
			elseif codestring == "313" then
				if notoriety_get("Brotherhood") == 5 then
					sandbox_message("Notoriety Brotherhood reset")
					notoriety_set("Brotherhood",0)
				else
					notoriety_set("Brotherhood",(notoriety_get("Brotherhood") +1))
					sandbox_message("Notoriety Brotherhood +1")
				end
				reset_input_sequence()
			elseif codestring == "314" then
				if notoriety_get("Police") == 5 then
					sandbox_message("Notoriety Police reset")
					notoriety_set("Police",0)
				else
					notoriety_set("Police",(notoriety_get("Police") +1))
					sandbox_message("Notoriety Police +1")
				end
				reset_input_sequence()
			elseif codestring == "315" then
				clear_other_gang_notoriety("Samedi")
				notoriety_set("Samedi",0)
				notoriety_set_min("Samedi", 0)
				notoriety_set_max("Samedi", 0)
				sandbox_message("Notoriety Samedi locked at 0")
				reset_input_sequence()
			elseif codestring == "316" then
				clear_other_gang_notoriety("Samedi")
				notoriety_set("Samedi",1)
				notoriety_set_min("Samedi", 1)
				notoriety_set_max("Samedi", 1)
				sandbox_message("Notoriety Samedi locked at 1")
				reset_input_sequence()
			elseif codestring == "317" then
				clear_other_gang_notoriety("Samedi")
				notoriety_set("Samedi",2)
				notoriety_set_min("Samedi", 2)
				notoriety_set_max("Samedi", 2)
				sandbox_message("Notoriety Samedi locked at 2")
				reset_input_sequence()
			elseif codestring == "318" then
				clear_other_gang_notoriety("Samedi")
				notoriety_set("Samedi",3)
				notoriety_set_min("Samedi", 3)
				notoriety_set_max("Samedi", 3)
				sandbox_message("Notoriety Samedi locked at 3")
				reset_input_sequence()
			elseif codestring == "321" then
				clear_other_gang_notoriety("Samedi")
				notoriety_set("Samedi",4)
				notoriety_set_min("Samedi", 4)
				notoriety_set_max("Samedi", 4)
				sandbox_message("Notoriety Samedi locked at 4")
				reset_input_sequence()
			elseif codestring == "322" then
				clear_other_gang_notoriety("Samedi")
				notoriety_set("Samedi",5)
				notoriety_set_min("Samedi", 5)
				notoriety_set_max("Samedi", 5)
				sandbox_message("Notoriety Samedi locked at 5")
				reset_input_sequence()
			elseif codestring == "323" then
				clear_other_gang_notoriety("Ronin")
				notoriety_set("Ronin",0)
				notoriety_set_min("Ronin", 0)
				notoriety_set_max("Ronin", 0)
				sandbox_message("Notoriety Ronin locked at 0")
				reset_input_sequence()
			elseif codestring == "324" then
				clear_other_gang_notoriety("Ronin")
				notoriety_set("Ronin",1)
				notoriety_set_min("Ronin", 1)
				notoriety_set_max("Ronin", 1)
				sandbox_message("Notoriety Ronin locked at 1")
				reset_input_sequence()
			elseif codestring == "325" then
				clear_other_gang_notoriety("Ronin")
				notoriety_set("Ronin",2)
				notoriety_set_min("Ronin", 2)
				notoriety_set_max("Ronin", 2)
				sandbox_message("Notoriety Ronin locked at 2")
				reset_input_sequence()
			elseif codestring == "326" then
				clear_other_gang_notoriety("Ronin")
				notoriety_set("Ronin",3)
				notoriety_set_min("Ronin", 3)
				notoriety_set_max("Ronin", 3)
				sandbox_message("Notoriety Ronin locked at 3")
				reset_input_sequence()
			elseif codestring == "327" then
				clear_other_gang_notoriety("Ronin")
				notoriety_set("Ronin",4)
				notoriety_set_min("Ronin", 4)
				notoriety_set_max("Ronin", 4)
				sandbox_message("Notoriety Ronin locked at 4")
				reset_input_sequence()
			elseif codestring == "328" then
				clear_other_gang_notoriety("Ronin")
				notoriety_set("Ronin",5)
				notoriety_set_min("Ronin", 5)
				notoriety_set_max("Ronin", 5)
				sandbox_message("Notoriety Ronin locked at 5")
				reset_input_sequence()
			elseif codestring == "331" then
				clear_other_gang_notoriety("Brotherhood")
				notoriety_set("Brotherhood",0)
				notoriety_set_min("Brotherhood", 0)
				notoriety_set_max("Brotherhood", 0)
				sandbox_message("Notoriety Brotherhood locked at 0")
				reset_input_sequence()
			elseif codestring == "332" then
				clear_other_gang_notoriety("Brotherhood")
				notoriety_set("Brotherhood",1)
				notoriety_set_min("Brotherhood", 1)
				notoriety_set_max("Brotherhood", 1)
				sandbox_message("Notoriety Brotherhood locked at 1")
				reset_input_sequence()
			elseif codestring == "333" then
				clear_other_gang_notoriety("Brotherhood")
				notoriety_set("Brotherhood",2)
				notoriety_set_min("Brotherhood", 2)
				notoriety_set_max("Brotherhood", 2)
				sandbox_message("Notoriety Brotherhood locked at 2")
				reset_input_sequence()
			elseif codestring == "334" then
				clear_other_gang_notoriety("Brotherhood")
				notoriety_set("Brotherhood",3)
				notoriety_set_min("Brotherhood", 3)
				notoriety_set_max("Brotherhood", 3)
				sandbox_message("Notoriety Brotherhood locked at 3")
				reset_input_sequence()
			elseif codestring == "335" then
				clear_other_gang_notoriety("Brotherhood")
				notoriety_set("Brotherhood",4)
				notoriety_set_min("Brotherhood", 4)
				notoriety_set_max("Brotherhood", 4)
				sandbox_message("Notoriety Brotherhood locked at 4")
				reset_input_sequence()
			elseif codestring == "336" then
				clear_other_gang_notoriety("Brotherhood")
				notoriety_set("Brotherhood",5)
				notoriety_set_min("Brotherhood", 5)
				notoriety_set_max("Brotherhood", 5)
				sandbox_message("Notoriety Brotherhood locked at 5")
				reset_input_sequence()
			elseif codestring == "337" then
				notoriety_set("Police",0)
				notoriety_set_min("Police", 0)
				notoriety_set_max("Police", 0)
				sandbox_message("Notoriety Police locked at 0")
				reset_input_sequence()
			elseif codestring == "338" then
				notoriety_set("Police",1)
				notoriety_set_min("Police", 1)
				notoriety_set_max("Police", 1)
				sandbox_message("Notoriety Police locked at 1")
				reset_input_sequence()
			elseif codestring == "341" then
				notoriety_set("Police",2)
				notoriety_set_min("Police", 2)
				notoriety_set_max("Police", 2)
				sandbox_message("Notoriety Police locked at 2")
				reset_input_sequence()
			elseif codestring == "342" then
				notoriety_set("Police",3)
				notoriety_set_min("Police", 3)
				notoriety_set_max("Police", 3)
				sandbox_message("Notoriety Police locked at 3")
				reset_input_sequence()
			elseif codestring == "343" then
				notoriety_set("Police",4)
				notoriety_set_min("Police", 4)
				notoriety_set_max("Police", 4)
				sandbox_message("Notoriety Police locked at 4")
				reset_input_sequence()
			elseif codestring == "344" then
				notoriety_set("Police",5)
				notoriety_set_min("Police", 5)
				notoriety_set_max("Police", 5)
				sandbox_message("Notoriety Police locked at 5")
				reset_input_sequence()
			elseif codestring == "345" then
				remove_all_notoriety_locks()
				sandbox_message("All notoriety locks removed")
				reset_input_sequence()
			elseif codestring == "346" then
				remove_all_notoriety_locks()
				clear_all_notoriety()
				sandbox_message("All notoriety cleared")
				reset_input_sequence()
			elseif codestring == "347" then
				set_team( LOCAL_PLAYER , "Samedi")
				if COOP_COMMANDS_ACTIVE then
					set_team( REMOTE_PLAYER , "Samedi")
				end
				sandbox_message("Player team set to Samedi")
				reset_input_sequence()
			elseif codestring == "348" then
				set_team( LOCAL_PLAYER , "Ronin")
				if COOP_COMMANDS_ACTIVE then
					set_team( REMOTE_PLAYER , "Ronin")
				end
				sandbox_message("Player team set to Ronin")
				reset_input_sequence()
			elseif codestring == "351" then
				set_team( LOCAL_PLAYER , "Brotherhood")
				if COOP_COMMANDS_ACTIVE then
					set_team( REMOTE_PLAYER , "Brotherhood")
				end
				sandbox_message("Player team set to Brotherhood")
				reset_input_sequence()
			elseif codestring == "352" then
				set_team( LOCAL_PLAYER , "Police")
				if COOP_COMMANDS_ACTIVE then
					set_team( REMOTE_PLAYER , "Police")
				end
				sandbox_message("Player team set to Police")
				reset_input_sequence()
			elseif codestring == "353" then
				set_team( LOCAL_PLAYER , "Playas")
				if COOP_COMMANDS_ACTIVE then
					set_team( REMOTE_PLAYER , "Playas")
				end
				sandbox_message("Player team set to Saints")
				reset_input_sequence()
			elseif codestring == "354" then
				if not SPP_RESTRICTED_ZONES then
					notoriety_restricted_zones_enable(true)
					sandbox_message("Restricted zones enabled")
				else
					notoriety_restricted_zones_enable(false)
					sandbox_message("Restricted zones disabled")
				end
				SPP_RESTRICTED_ZONES = not SPP_RESTRICTED_ZONES
				reset_input_sequence()
			elseif codestring == "355" then
				if not SPP_INDOOR_GANG then
					notoriety_allow_indoor_gang_spawning(true)
					sandbox_message("RSSC notoriety gang spawn enabled")
				else
					notoriety_allow_indoor_gang_spawning(false)
					sandbox_message("RSSC notoriety gang spawn disabled")
				end
				SPP_INDOOR_GANG = not SPP_INDOOR_GANG
				reset_input_sequence()


			elseif codestring == "411" then
				clear_animation_state(LOCAL_PLAYER)
				sandbox_message("Current player animation cleared", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "412" then
				set_animation_state(LOCAL_PLAYER, "Arcade Stand")
				sandbox_message("Player animation Arcade Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "413" then
				set_animation_state(LOCAL_PLAYER, "arrest cuffed")
				sandbox_message("Player animation arrest cuffed", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "414" then
				set_animation_state(LOCAL_PLAYER, "atm using")
				sandbox_message("Player animation atm using", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "415" then
				set_animation_state(LOCAL_PLAYER, "back liedown")
				sandbox_message("Player animation back liedown", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "416" then
				set_animation_state(LOCAL_PLAYER, "BeachChair Sit")
				sandbox_message("Player animation BeachChair Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "417" then
				set_animation_state(LOCAL_PLAYER, "BeachTowel Lay A")
				sandbox_message("Player animation BeachTowel Lay A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "418" then
				set_animation_state(LOCAL_PLAYER, "BeachTowel Lay B")
				sandbox_message("Player animation BeachTowel Lay B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "421" then
				set_animation_state(LOCAL_PLAYER, "Begger Stand")
				sandbox_message("Player animation Begger Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "422" then
				set_animation_state(LOCAL_PLAYER, "Bench Beverage")
				sandbox_message("Player animation Bench Beverage", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "423" then
				set_animation_state(LOCAL_PLAYER, "Bench Cellphone")
				sandbox_message("Player animation Bench Cellphone", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "424" then
				set_animation_state(LOCAL_PLAYER, "Bench Laptop")
				sandbox_message("Player animation Bench Laptop", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "425" then
				set_animation_state(LOCAL_PLAYER, "Bench Lean")
				sandbox_message("Player animation Bench Lean", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "426" then
				set_animation_state(LOCAL_PLAYER, "Bench Newspaper")
				sandbox_message("Player animation Bench Newspaper", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "427" then
				set_animation_state(LOCAL_PLAYER, "BlackJack Sit")
				sandbox_message("Player animation BlackJack Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "428" then
				set_animation_state(LOCAL_PLAYER, "blunt smoking B")
				sandbox_message("Player animation blunt smoking B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "431" then
				set_animation_state(LOCAL_PLAYER, "blunt smoking")
				sandbox_message("Player animation blunt smoking", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "432" then
				set_animation_state(LOCAL_PLAYER, "Bum sleep")
				sandbox_message("Player animation Bum sleep", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "433" then
				set_animation_state(LOCAL_PLAYER, "cell stand txt")
				sandbox_message("Player animation cell stand txt", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "434" then
				set_animation_state(LOCAL_PLAYER, "cell stand")
				sandbox_message("Player animation cell stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "435" then
				set_animation_state(LOCAL_PLAYER, "Chair Beverage")
				sandbox_message("Player animation Chair Beverage", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "436" then
				set_animation_state(LOCAL_PLAYER, "Chair Cellphone")
				sandbox_message("Player animation Chair Cellphone", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "437" then
				set_animation_state(LOCAL_PLAYER, "Chair Cower A")
				sandbox_message("Player animation Chair Cower A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "438" then
				set_animation_state(LOCAL_PLAYER, "Chair Cower B")
				sandbox_message("Player animation Chair Cower B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "441" then
				set_animation_state(LOCAL_PLAYER, "Chair Cower C")
				sandbox_message("Player animation Chair Cower C", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "442" then
				set_animation_state(LOCAL_PLAYER, "Chair Drink")
				sandbox_message("Player animation Chair Drink", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "443" then
				set_animation_state(LOCAL_PLAYER, "Chair Eat")
				sandbox_message("Player animation Chair Eat", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "444" then
				set_animation_state(LOCAL_PLAYER, "Chair Laptop")
				sandbox_message("Player animation Chair Laptop", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "445" then
				set_animation_state(LOCAL_PLAYER, "Chair Newspaper")
				sandbox_message("Player animation Chair Newspaper", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "446" then
				set_animation_state(LOCAL_PLAYER, "Chair Sit")
				sandbox_message("Player animation Chair Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "447" then
				set_animation_state(LOCAL_PLAYER, "Clipboard Stand")
				sandbox_message("Player animation Clipboard Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "448" then
				set_animation_state(LOCAL_PLAYER, "Construction Hammer Kneel")
				sandbox_message("Player animation Construction Hammer Kneel", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "451" then
				set_animation_state(LOCAL_PLAYER, "Construction Jackhammer")
				sandbox_message("Player animation Construction Jackhammer", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "452" then
				set_animation_state(LOCAL_PLAYER, "Construction RoadSign Stand")
				sandbox_message("Player animation Construction RoadSign Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "453" then
				set_animation_state(LOCAL_PLAYER, "Construction Saw Stand")
				sandbox_message("Player animation Construction Saw Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "454" then
				set_animation_state(LOCAL_PLAYER, "cower run variant 1")
				sandbox_message("Player animation cower run variant 1", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "455" then
				set_animation_state(LOCAL_PLAYER, "cower run variant 2")
				sandbox_message("Player animation cower run variant 2", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "456" then
				set_animation_state(LOCAL_PLAYER, "cower run variant 3")
				sandbox_message("Player animation cower run variant 3", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "457" then
				set_animation_state(LOCAL_PLAYER, "cower run variant 4")
				sandbox_message("Player animation cower run variant 4", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "458" then
				set_animation_state(LOCAL_PLAYER, "cower run variant 5")
				sandbox_message("Player animation cower run variant 5", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "461" then
				set_animation_state(LOCAL_PLAYER, "cower run")
				sandbox_message("Player animation cower run", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "462" then
				set_animation_state(LOCAL_PLAYER, "cower stand variant 1")
				sandbox_message("Player animation cower stand variant 1", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "463" then
				set_animation_state(LOCAL_PLAYER, "cower stand variant 2")
				sandbox_message("Player animation cower stand variant 2", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "464" then
				set_animation_state(LOCAL_PLAYER, "cower stand variant 3")
				sandbox_message("Player animation cower stand variant 3", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "465" then
				set_animation_state(LOCAL_PLAYER, "cower stand")
				sandbox_message("Player animation cower stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "466" then
				set_animation_state(LOCAL_PLAYER, "cpr crouch pressing")
				sandbox_message("Player animation cpr crouch pressing", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "467" then
				set_animation_state(LOCAL_PLAYER, "cpr crouch state 1")
				sandbox_message("Player animation cpr crouch state 1", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "468" then
				set_animation_state(LOCAL_PLAYER, "cpr crouch state 2")
				sandbox_message("Player animation cpr crouch state 2", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "471" then
				set_animation_state(LOCAL_PLAYER, "cpr liedown")
				sandbox_message("Player animation cpr liedown", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "472" then
				set_animation_state(LOCAL_PLAYER, "CRIB Sit Ground")
				sandbox_message("Player animation CRIB Sit Ground", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "473" then
				set_animation_state(LOCAL_PLAYER, "CRIB Steel Drums")
				sandbox_message("Player animation CRIB Steel Drums", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "474" then
				set_animation_state(LOCAL_PLAYER, "crouch eat")
				sandbox_message("Player animation crouch eat", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "475" then
				set_animation_state(LOCAL_PLAYER, "crouch plant bomb")
				sandbox_message("Player animation crouch plant bomb", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "476" then
				set_animation_state(LOCAL_PLAYER, "dance a")
				sandbox_message("Player animation Dance A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "477" then
				set_animation_state(LOCAL_PLAYER, "dance b")
				sandbox_message("Player animation Dance B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "478" then
				set_animation_state(LOCAL_PLAYER, "dance c")
				sandbox_message("Player animation Dance C", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "481" then
				set_animation_state(LOCAL_PLAYER, "dance d")
				sandbox_message("Player animation Dance D", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "482" then
				set_animation_state(LOCAL_PLAYER, "defib crouch charging")
				sandbox_message("Player animation defib crouch charging", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "483" then
				set_animation_state(LOCAL_PLAYER, "defib flinch facedown")
				sandbox_message("Player animation defib flinch facedown", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "484" then
				set_animation_state(LOCAL_PLAYER, "defib flinch faceup")
				sandbox_message("Player animation defib flinch faceup", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "485" then
				set_animation_state(LOCAL_PLAYER, "dial safe combo")
				sandbox_message("Player animation dial safe combo", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "486" then
				set_animation_state(LOCAL_PLAYER, "drunk flee walk A")
				sandbox_message("Player animation drunk flee walk A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "487" then
				set_animation_state(LOCAL_PLAYER, "drunk flee walk B")
				sandbox_message("Player animation drunk flee walk B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "488" then
				set_animation_state(LOCAL_PLAYER, "drunk run")
				sandbox_message("Player animation drunk run", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "511" then
				set_animation_state(LOCAL_PLAYER, "drunk stand")
				sandbox_message("Player animation drunk stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "512" then
				set_animation_state(LOCAL_PLAYER, "drunk walk")
				sandbox_message("Player animation drunk walk", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "513" then
				set_animation_state(LOCAL_PLAYER, "fall dead")
				sandbox_message("Player animation fall dead", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "514" then
				set_animation_state(LOCAL_PLAYER, "Fishing Stand")
				sandbox_message("Player animation Fishing Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "515" then
				set_animation_state(LOCAL_PLAYER, "FlashBanged")
				sandbox_message("Player animation FlashBanged", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "516" then
				set_animation_state(LOCAL_PLAYER, "flashing open stand")
				sandbox_message("Player animation flashing open stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "517" then
				set_animation_state(LOCAL_PLAYER, "Flee Walk A")
				sandbox_message("Player animation Flee Walk A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "518" then
				set_animation_state(LOCAL_PLAYER, "flip fall")
				sandbox_message("Player animation flip fall", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "521" then
				set_animation_state(LOCAL_PLAYER, "Flyer Stand")
				sandbox_message("Player animation Flyer Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "522" then
				set_animation_state(LOCAL_PLAYER, "forty drinking")
				sandbox_message("Player animation forty drinking", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "523" then
				set_animation_state(LOCAL_PLAYER, "forty drinking B")
				sandbox_message("Player animation forty drinking B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "524" then
				set_animation_state(LOCAL_PLAYER, "forty drinking walk")
				sandbox_message("Player animation forty drinking walk", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "525" then
				set_animation_state(LOCAL_PLAYER, "GroundReading Sit")
				sandbox_message("Player animation GroundReading Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "526" then
				set_animation_state(LOCAL_PLAYER, "guitar stand")
				sandbox_message("Player animation guitar stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "527" then
				set_animation_state(LOCAL_PLAYER, "Gurney Sleep A")
				sandbox_message("Player animation Gurney Sleep A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "528" then
				set_animation_state(LOCAL_PLAYER, "Gurney Sleep B")
				sandbox_message("Player animation Gurney Sleep B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "531" then
				set_animation_state(LOCAL_PLAYER, "Head Cover Run")
				sandbox_message("Player animation Head Cover Run", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "532" then
				set_animation_state(LOCAL_PLAYER, "Head Cover Stand")
				sandbox_message("Player animation Head Cover Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "533" then
				set_animation_state(LOCAL_PLAYER, "Head Cover Walk")
				sandbox_message("Player animation Head Cover Walk", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "534" then
				set_animation_state(LOCAL_PLAYER, "HedgeTrimmer Stand")
				sandbox_message("Player animation HedgeTrimmer Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "535" then
				set_animation_state(LOCAL_PLAYER, "Helmet Sit")
				sandbox_message("Player animation Helmet Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "536" then
				set_animation_state(LOCAL_PLAYER, "hose sprayed")
				sandbox_message("Player animation hose sprayed", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "537" then
				set_animation_state(LOCAL_PLAYER, "Inmate Bang Cup")
				sandbox_message("Player animation Inmate Bang Cup", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "538" then
				set_animation_state(LOCAL_PLAYER, "Inmate Bars Stand")
				sandbox_message("Player animation Inmate Bars Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "541" then
				set_animation_state(LOCAL_PLAYER, "Inmate Curl Stand")
				sandbox_message("Player animation Inmate Curl Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "542" then
				set_animation_state(LOCAL_PLAYER, "Inmate Harmonica Stand")
				sandbox_message("Player animation Inmate Harmonica Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "543" then
				set_animation_state(LOCAL_PLAYER, "Inmate Scrub Kneel")
				sandbox_message("Player animation Inmate Scrub Kneel", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "544" then
				set_animation_state(LOCAL_PLAYER, "Inmate Write Sit")
				sandbox_message("Player animation Inmate Write Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "545" then
				set_animation_state(LOCAL_PLAYER, "Juggle")
				sandbox_message("Player animation Juggle", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "546" then
				set_animation_state(LOCAL_PLAYER, "Junkie Ground")
				sandbox_message("Player animation Junkie Ground", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "547" then
				set_animation_state(LOCAL_PLAYER, "Lapdance Sit Get")
				sandbox_message("Player animation Lapdance Sit Get", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "548" then
				set_animation_state(LOCAL_PLAYER, "Lapdance Stand Give")
				sandbox_message("Player animation Lapdance Stand Give", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "551" then
				set_animation_state(LOCAL_PLAYER, "Laptop Ground")
				sandbox_message("Player animation Laptop Ground", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "552" then
				set_animation_state(LOCAL_PLAYER, "Lawnchair Lounge")
				sandbox_message("Player animation Lawnchair Lounge", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "553" then
				set_animation_state(LOCAL_PLAYER, "Lawnchair Sit")
				sandbox_message("Player animation Lawnchair Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "554" then
				set_animation_state(LOCAL_PLAYER, "Lean")
				sandbox_message("Player animation Lean", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "555" then
				set_animation_state(LOCAL_PLAYER, "Lifeguard Sit")
				sandbox_message("Player animation Lifeguard Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "556" then
				set_animation_state(LOCAL_PLAYER, "Limbo Dance A")
				sandbox_message("Player animation Limbo Dance A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "557" then
				set_animation_state(LOCAL_PLAYER, "Limbo Dance B")
				sandbox_message("Player animation Limbo Dance B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "558" then
				set_animation_state(LOCAL_PLAYER, "Limbo Pole Stand Left")
				sandbox_message("Player animation Limbo Pole Stand Left", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "561" then
				set_animation_state(LOCAL_PLAYER, "Limbo Pole Stand Right")
				sandbox_message("Player animation Limbo Pole Stand Right", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "562" then
				set_animation_state(LOCAL_PLAYER, "Lookout Stand")
				sandbox_message("Player animation Lookout Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "563" then
				set_animation_state(LOCAL_PLAYER, "Lounge")
				sandbox_message("Player animation Lounge", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "564" then
				set_animation_state(LOCAL_PLAYER, "Lover Sit A")
				sandbox_message("Player animation Lover Sit A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "565" then
				set_animation_state(LOCAL_PLAYER, "Lover Sit B")
				sandbox_message("Player animation Lover Sit B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "566" then
				set_animation_state(LOCAL_PLAYER, "Megaphone Stand")
				sandbox_message("Player animation Megaphone Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "567" then
				set_animation_state(LOCAL_PLAYER, "Metal Detector Stand")
				sandbox_message("Player animation Metal Detector Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "568" then
				set_animation_state(LOCAL_PLAYER, "Mourn Crouch")
				sandbox_message("Player animation Mourn Crouch", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "571" then
				set_animation_state(LOCAL_PLAYER, "Nose Dive")
				sandbox_message("Player animation Nose Dive", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "572" then
				set_animation_state(LOCAL_PLAYER, "panic fall")
				sandbox_message("Player animation panic fall", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "573" then
				set_animation_state(LOCAL_PLAYER, "pant")
				sandbox_message("Player animation pant", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "574" then
				set_animation_state(LOCAL_PLAYER, "Piano Sit")
				sandbox_message("Player animation Piano Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "575" then
				set_animation_state(LOCAL_PLAYER, "Picnic Sit A")
				sandbox_message("Player animation Picnic Sit A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "576" then
				set_animation_state(LOCAL_PLAYER, "Picnic Sit B")
				sandbox_message("Player animation Picnic Sit B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "577" then
				set_animation_state(LOCAL_PLAYER, "PicnicTable Drink")
				sandbox_message("Player animation PicnicTable Drink", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "578" then
				set_animation_state(LOCAL_PLAYER, "PicnicTable Eat")
				sandbox_message("Player animation PicnicTable Eat", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "581" then
				set_animation_state(LOCAL_PLAYER, "PicnicTable Sit")
				sandbox_message("Player animation PicnicTable Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "582" then
				set_animation_state(LOCAL_PLAYER, "Pinball Stand")
				sandbox_message("Player animation Pinball Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "583" then
				set_animation_state(LOCAL_PLAYER, "Poker Sit")
				sandbox_message("Player animation Poker Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "584" then
				set_animation_state(LOCAL_PLAYER, "pole stand")
				sandbox_message("Player animation pole stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "585" then
				set_animation_state(LOCAL_PLAYER, "police call talk")
				sandbox_message("Player animation police call talk", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "586" then
				set_animation_state(LOCAL_PLAYER, "Pond Scoop Stand")
				sandbox_message("Player animation Pond Scoop Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "587" then
				set_animation_state(LOCAL_PLAYER, "Pool Stand")
				sandbox_message("Player animation Pool Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "588" then
				set_animation_state(LOCAL_PLAYER, "Pool Watch")
				sandbox_message("Player animation Pool Watch", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "611" then
				set_animation_state(LOCAL_PLAYER, "protest Stand")
				sandbox_message("Player animation protest Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "612" then
				set_animation_state(LOCAL_PLAYER, "Quartet Stand")
				sandbox_message("Player animation Quartet Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "613" then
				set_animation_state(LOCAL_PLAYER, "Rap Stand")
				sandbox_message("Player animation Rap Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "614" then
				set_animation_state(LOCAL_PLAYER, "react car wreck")
				sandbox_message("Player animation react car wreck", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "615" then
				set_animation_state(LOCAL_PLAYER, "react Cheer")
				sandbox_message("Player animation react Cheer", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "616" then
				set_animation_state(LOCAL_PLAYER, "react Cheer 2")
				sandbox_message("Player animation react Cheer 2", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "617" then
				set_animation_state(LOCAL_PLAYER, "react Over Body")
				sandbox_message("Player animation react Over Body", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "618" then
				set_animation_state(LOCAL_PLAYER, "react PepperSpray Stand")
				sandbox_message("Player animation react PepperSpray Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "621" then
				set_animation_state(LOCAL_PLAYER, "Security Scan Stand")
				sandbox_message("Player animation Security Scan Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "622" then
				set_animation_state(LOCAL_PLAYER, "ShoppingBag Stand")
				sandbox_message("Player animation ShoppingBag Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "623" then
				set_animation_state(LOCAL_PLAYER, "Singer Stand")
				sandbox_message("Player animation Singer Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "624" then
				set_animation_state(LOCAL_PLAYER, "Sketchpad Sit")
				sandbox_message("Player animation Sketchpad Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "625" then
				set_animation_state(LOCAL_PLAYER, "sleep")
				sandbox_message("Player animation sleep", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "626" then
				set_animation_state(LOCAL_PLAYER, "sleep b")
				sandbox_message("Player animation sleep b", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "627" then
				set_animation_state(LOCAL_PLAYER, "Slot Machine Sit")
				sandbox_message("Player animation Slot Machine Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "628" then
				set_animation_state(LOCAL_PLAYER, "Smoking B")
				sandbox_message("Player animation Smoking B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "631" then
				set_animation_state(LOCAL_PLAYER, "Sofa Cower A")
				sandbox_message("Player animation Sofa Cower A", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "632" then
				set_animation_state(LOCAL_PLAYER, "Sofa Cower B")
				sandbox_message("Player animation Sofa Cower B", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "633" then
				set_animation_state(LOCAL_PLAYER, "Sofa Sit")
				sandbox_message("Player animation Sofa Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "634" then
				set_animation_state(LOCAL_PLAYER, "Stool Beer")
				sandbox_message("Player animation Stool Beer", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "635" then
				set_animation_state(LOCAL_PLAYER, "Stool Cig")
				sandbox_message("Player animation Stool Cig", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "636" then
				set_animation_state(LOCAL_PLAYER, "Stool Sit")
				sandbox_message("Player animation Stool Sit", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "637" then
				set_animation_state(LOCAL_PLAYER, "streaking run")
				sandbox_message("Player animation streaking run", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "638" then
				set_animation_state(LOCAL_PLAYER, "streaking sprint")
				sandbox_message("Player animation streaking sprint", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "641" then
				set_animation_state(LOCAL_PLAYER, "streaking stand")
				sandbox_message("Player animation streaking stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "642" then
				set_animation_state(LOCAL_PLAYER, "Suicide Stand")
				sandbox_message("Player animation Suicide Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "643" then
				set_animation_state(LOCAL_PLAYER, "surrender")
				sandbox_message("Player animation surrender", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "644" then
				set_animation_state(LOCAL_PLAYER, "swim surface")
				sandbox_message("Player animation swim surface", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "645" then
				set_animation_state(LOCAL_PLAYER, "swim_slow")
				sandbox_message("Player animation swim_slow", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "646" then
				set_animation_state(LOCAL_PLAYER, "tag stand")
				sandbox_message("Player animation tag stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "647" then
				set_animation_state(LOCAL_PLAYER, "TaiChi Stand")
				sandbox_message("Player animation TaiChi Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "648" then
				set_animation_state(LOCAL_PLAYER, "Tap Dancer Stand")
				sandbox_message("Player animation Tap Dancer Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "651" then
				set_animation_state(LOCAL_PLAYER, "Tourist Stand")
				sandbox_message("Player animation Tourist Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "652" then
				set_animation_state(LOCAL_PLAYER, "tread")
				sandbox_message("Player animation tread", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "653" then
				set_animation_state(LOCAL_PLAYER, "Umbrella Run")
				sandbox_message("Player animation Umbrella Run", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "654" then
				set_animation_state(LOCAL_PLAYER, "Umbrella Stand")
				sandbox_message("Player animation Umbrella Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "655" then
				set_animation_state(LOCAL_PLAYER, "Umbrella Walk")
				sandbox_message("Player animation Umbrella Walk", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "656" then
				set_animation_state(LOCAL_PLAYER, "vehicle surf handstand")
				sandbox_message("Player animation vehicle surf handstand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "657" then
				set_animation_state(LOCAL_PLAYER, "vehicle surf lean left")
				sandbox_message("Player animation vehicle surf lean left", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "658" then
				set_animation_state(LOCAL_PLAYER, "vehicle surf lean right")
				sandbox_message("Player animation vehicle surf lean right", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "661" then
				set_animation_state(LOCAL_PLAYER, "vehicle surf stand")
				sandbox_message("Player animation vehicle surf stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "662" then
				set_animation_state(LOCAL_PLAYER, "Warmhands Stand")
				sandbox_message("Player animation Warmhands Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "663" then
				set_animation_state(LOCAL_PLAYER, "Watch Rain")
				sandbox_message("Player animation Watch Rain", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "664" then
				set_animation_state(LOCAL_PLAYER, "worried fall")
				sandbox_message("Player animation worried fall", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "665" then
				set_animation_state(LOCAL_PLAYER, "YKZA Sword Stand")
				sandbox_message("Player animation YKZA Sword Stand", LOCAL_PLAYER)
				reset_input_sequence()
			elseif codestring == "666" then
				set_animation_state(LOCAL_PLAYER, "Yoga Sit")
				sandbox_message("Player animation Yoga Sit", LOCAL_PLAYER)
				reset_input_sequence()



			elseif codestring == "671" then
				spp_outfit_wear("Police Outfit")
			elseif codestring == "672" then
				spp_outfit_wear("Suit 1", "Crowd Control Outfit")
			elseif codestring == "673" then
				spp_outfit_wear("Sexy 1")
			elseif codestring == "674" then
				spp_outfit_wear("Street 1")
			elseif codestring == "675" then
				spp_outfit_wear("Crazy 1")
			elseif codestring == "676" then
				spp_outfit_wear("Repair", "Video Repair")
			elseif codestring == "677" then
				spp_outfit_wear("Streaker")
			elseif codestring == "678" then
				spp_outfit_wear("Suit purple man")
			elseif codestring == "681" then
				spp_outfit_wear("Suit purple woman")
			elseif codestring == "682" then
				spp_outfit_wear("Fire Fighter")
			elseif codestring == "683" then
				spp_outfit_wear("Pimp 1")
			elseif codestring == "684" then
				spp_outfit_wear("Fire Suit", "Fire Suit (Immune to Fire Damage)")
			elseif codestring == "685" then
				spp_outfit_wear("Prison")
			elseif codestring == "686" then
				spp_outfit_wear("Pirate")
			elseif codestring == "687" then
				spp_outfit_wear("Cat")
			elseif codestring == "688" then
				spp_outfit_wear("Evil Doctor")
			elseif codestring == "711" then
				spp_outfit_wear("Slasher 1")
			elseif codestring == "712" then
				spp_outfit_wear("Hippie")
			elseif codestring == "713" then
				spp_outfit_wear("Barbershop")
			elseif codestring == "714" then
				spp_outfit_wear("Construction")
			elseif codestring == "715" then
				spp_outfit_wear("Hazmat")
			elseif codestring == "716" then
				spp_outfit_wear("Clown")
			elseif codestring == "717" then
				spp_outfit_wear("Mime")
			elseif codestring == "718" then
				spp_outfit_wear("Japanese Streaker Female")
			elseif codestring == "721" then
				spp_outfit_wear("Japanese Streaker Male")
			elseif codestring == "722" then
				spp_outfit_wear("Indy")
			elseif codestring == "723" then
				spp_outfit_wear("Shaundi")
			elseif codestring == "724" then
				spp_outfit_wear("Gyros")
			elseif codestring == "725" then
				spp_outfit_wear("Tobias")
			elseif codestring == "726" then
				spp_outfit_wear("Veteran Child")
			elseif codestring == "727" then
				spp_outfit_wear("Mr Sunshine")
			elseif codestring == "728" then
				spp_outfit_wear("The General")
			elseif codestring == "731" then
				spp_outfit_wear("Donnie")
			elseif codestring == "732" then
				spp_outfit_wear("Jessica")
			elseif codestring == "733" then
				spp_outfit_wear("Matt")
			elseif codestring == "734" then
				spp_outfit_wear("Carlos")
			elseif codestring == "735" then
				spp_outfit_wear("Maero")
			elseif codestring == "736" then
				spp_outfit_wear("Jyunichi")
			elseif codestring == "737" then
				spp_outfit_wear("Shogo")
			elseif codestring == "738" then
				spp_outfit_wear("Pierce")
			elseif codestring == "741" then
				spp_outfit_wear("Wong")
			elseif codestring == "742" then
				spp_outfit_wear("Kazuo")
			elseif codestring == "743" then
				spp_outfit_wear("Gat")
			elseif codestring == "744" then
				spp_outfit_wear("Dane Vogel")
			elseif codestring == "745" then
				spp_outfit_wear("Julius")
			elseif codestring == "746" then
				spp_outfit_wear("Lara")
			elseif codestring == "747" then
				spp_outfit_wear("Solo")
			elseif codestring == "748" then
				spp_outfit_wear("Lara2")
			elseif codestring == "751" then
				spp_outfit_wear("Agent47")
			elseif codestring == "752" then
				spp_outfit_wear("Riddler")
			elseif codestring == "753" then
				spp_outfit_wear("Tommy")
			elseif codestring == "754" then
				spp_outfit_wear("Funkmaster")
			elseif codestring == "755" then
				spp_outfit_wear("Clockwork")
			elseif codestring == "756" then
				spp_outfit_wear("Pancho")
			elseif codestring == "757" then
				spp_outfit_wear("Zangief")
			elseif codestring == "758" then
				spp_outfit_wear("Diver")
			elseif codestring == "761" then
				spp_outfit_wear("Cage")
			elseif codestring == "762" then
				spp_outfit_wear("Devil Girl")
			elseif codestring == "763" then
				spp_outfit_wear("Joker")
			elseif codestring == "764" then
				spp_outfit_wear("OKUSA")
			elseif codestring == "765" then
				spp_outfit_wear("Fancy")
			elseif codestring == "766" then
				spp_outfit_wear("SamLunch")
			elseif codestring == "767" then
				spp_outfit_wear("Guile")
			elseif codestring == "768" then
				spp_outfit_wear("Firespite")
			elseif codestring == "771" then
				spp_outfit_wear("TC")
			elseif codestring == "772" then
				spp_outfit_wear("Mordrack")
			elseif codestring == "773" then
				spp_outfit_wear("Aisha")
			elseif codestring == "774" then
				spp_outfit_wear("Luz")
			elseif codestring == "775" then
				spp_outfit_wear("GatSuit")
			elseif codestring == "776" then
				spp_outfit_wear("Masako")
			elseif codestring == "777" then
				spp_outfit_wear("Swat")
			elseif codestring == "778" then
				spp_outfit_wear("FBI")
			elseif codestring == "781" then
				spp_outfit_wear("Goon")
			elseif codestring == "782" then
				spp_outfit_wear("LukeFighter")
			elseif codestring == "783" then
				spp_outfit_wear("Hulkster")
			elseif codestring == "784" then
				spp_outfit_wear("LupinGreen")
			elseif codestring == "785" then
				spp_outfit_wear("LupinRed")
			elseif codestring == "786" then
				spp_outfit_wear("Jigen")



			elseif codestring == "811" then
				if not SANDBOX_MESSAGES then
					mission_help_clear(SYNC_ALL)
					mission_help_table_nag("CODE ENTRY: "..codestring.."\n".."Sandbox+ messages toggled on in HUD", "", "", SYNC_ALL)
				else
					mission_help_clear(SYNC_ALL)
					mission_help_table_nag("CODE ENTRY: "..codestring.."\n".."Sandbox+ messages toggled off in HUD", "", "", SYNC_ALL)
				end
				SANDBOX_MESSAGES = not SANDBOX_MESSAGES		
				reset_input_sequence()
			elseif codestring == "812" then
				--toggle if coop commands are active (off by default)
				if coop_is_active() then
					if not COOP_COMMANDS_ACTIVE then
						sandbox_message("Sandbox+ commands now affect both host and remote player", LOCAL_PLAYER)
					else
						sandbox_message("Sandbox+ commands now only affect the host", LOCAL_PLAYER)
					end
					COOP_COMMANDS_ACTIVE = not COOP_COMMANDS_ACTIVE
				else
					sandbox_message("Coop is currently not active", LOCAL_PLAYER)
				end
				reset_input_sequence()
			elseif codestring == "813" then
				cash_add( 100000, LOCAL_PLAYER )
				if COOP_COMMANDS_ACTIVE then
					cash_add( 100000, REMOTE_PLAYER )
				end
				sandbox_message("Player received $100,000")
				reset_input_sequence()
			elseif codestring == "814" then
				local player_repaired = false
				local partner_repaired = false
				
				-- Repair Host Player's Vehicle
				local player_vehicle, partner_vehicle = spp_get_player_vehicle_names()
				if (player_vehicle ~= "") then
					vehicle_repair( player_vehicle )
					player_repaired = true
				end
				-- Repair Co-op Player's vehicle [nclok1405]
				if (partner_vehicle ~= "") then
					vehicle_repair( partner_vehicle )
					partner_repaired = true
				end
				
				if player_repaired and partner_repaired then
					sandbox_message("Both player's vehicles repaired")
				elseif player_repaired then
					sandbox_message("Player's vehicle repaired")
				elseif partner_repaired then
					sandbox_message("Partner's vehicle repaired")
				else
					sandbox_message("Player is not in a vehicle")
				end
				
				reset_input_sequence()
			elseif codestring == "815" then
				if not WEAPON_SWAP_DISABLED then
					inv_weapon_disable_all_but_this_slot( WEAPON_SLOT_UNARMED )
					sandbox_message("Player weapons are disabled", LOCAL_PLAYER)
				else
					inv_weapon_enable_or_disable_all_slots( true )
					sandbox_message("Player weapons are enabled", LOCAL_PLAYER)
				end
				WEAPON_SWAP_DISABLED = not WEAPON_SWAP_DISABLED
				reset_input_sequence()

			elseif codestring == "816" then
				if not SPP_COP_DRIVEBY then
					set_cops_shooting_from_vehicles(true)
					sandbox_message("Cops shooting from vehicles enabled")
				else
					set_cops_shooting_from_vehicles(false)
					sandbox_message("Cops shooting from vehicles disabled")
				end
				SPP_COP_DRIVEBY = not SPP_COP_DRIVEBY
				reset_input_sequence()
			elseif codestring == "817" then
				if SPP_SPAWNING_PEDS == 0 then
					set_ped_density(0)
					spawning_pedestrians(false)
					sandbox_message("Walking pedestrians spawn: Disabled")
					SPP_SPAWNING_PEDS = 1
				elseif SPP_SPAWNING_PEDS == 1 then
					set_ped_density(0.1)
					spawning_pedestrians(true)
					sandbox_message("Walking pedestrians spawn: 0.1")
					SPP_SPAWNING_PEDS = 2
				elseif SPP_SPAWNING_PEDS == 2 then
					set_ped_density(0.5)
					spawning_pedestrians(true)
					sandbox_message("Walking pedestrians spawn: 0.5")
					SPP_SPAWNING_PEDS = 3
				elseif SPP_SPAWNING_PEDS == 3 then
					set_ped_density(1)
					spawning_pedestrians(true)
					sandbox_message("Walking pedestrians spawn: 1.0")
					SPP_SPAWNING_PEDS = 4
				elseif SPP_SPAWNING_PEDS == 4 then
					set_ped_density(2)
					spawning_pedestrians(true)
					sandbox_message("Walking pedestrians spawn: 2.0")
					SPP_SPAWNING_PEDS = 0
				end
				reset_input_sequence()
			elseif codestring == "818" then
				if not SPP_SPAWNING_ACTION_NODE_PEDS then
					action_nodes_restrict_spawning(false)
					sandbox_message("Action-node (non-walking) pedestrians spawn enabled")
				else
					action_nodes_restrict_spawning(true)
					sandbox_message("Action-node (non-walking) pedestrians spawn disabled")
				end
				SPP_SPAWNING_ACTION_NODE_PEDS = not SPP_SPAWNING_ACTION_NODE_PEDS
				reset_input_sequence()
			elseif codestring == "821" then
				if not SPP_SPAWNING_VEHICLES then
					spawning_vehicles(true)
					sandbox_message("Traffic enabled")
				else
					spawning_vehicles(false)
					sandbox_message("Traffic disabled")
				end
				SPP_SPAWNING_VEHICLES = not SPP_SPAWNING_VEHICLES
				reset_input_sequence()
			elseif codestring == "822" then
				if SPP_ENABLE_TRAFFIC == 0 then
					set_traffic_density(0)
					sandbox_message("Civilian Traffic: Disabled")
					SPP_ENABLE_TRAFFIC = 1
				elseif SPP_ENABLE_TRAFFIC == 1 then
					set_traffic_density(0.1)
					sandbox_message("Civilian Traffic: 0.1")
					SPP_ENABLE_TRAFFIC = 2
				elseif SPP_ENABLE_TRAFFIC == 2 then
					set_traffic_density(0.5)
					sandbox_message("Civilian Traffic: 0.5")
					SPP_ENABLE_TRAFFIC = 3
				elseif SPP_ENABLE_TRAFFIC == 3 then
					set_traffic_density(1)
					sandbox_message("Civilian Traffic: 1.0")
					SPP_ENABLE_TRAFFIC = 4
				elseif SPP_ENABLE_TRAFFIC == 4 then
					set_traffic_density(2)
					sandbox_message("Civilian Traffic: 2.0")
					SPP_ENABLE_TRAFFIC = 0
				end
				reset_input_sequence()
			elseif codestring == "823" then
				if not SPP_ENABLE_AMBIENT_COP_SPAWNS then
					ambient_cop_spawn_enable(true)
					spawning_allow_cop_ambient_spawns(true)
					sandbox_message("Ambient Cop Spawn enabled")
				else
					ambient_cop_spawn_enable(false)
					spawning_allow_cop_ambient_spawns(false)
					sandbox_message("Ambient Cop Spawn disabled")
				end
				SPP_ENABLE_AMBIENT_COP_SPAWNS = not SPP_ENABLE_AMBIENT_COP_SPAWNS
				reset_input_sequence()
			elseif codestring == "824" then
				if not SPP_ENABLE_AMBIENT_GANG_SPAWNS then
					ambient_gang_spawn_enable(true)
					spawning_allow_gang_ambient_spawns(true)
					sandbox_message("Ambient Gang Spawn enabled")
				else
					ambient_gang_spawn_enable(false)
					spawning_allow_gang_ambient_spawns(false)
					sandbox_message("Ambient Gang Spawn disabled")
				end
				SPP_ENABLE_AMBIENT_GANG_SPAWNS = not SPP_ENABLE_AMBIENT_GANG_SPAWNS
				reset_input_sequence()
			elseif codestring == "825" then
				if not SPP_ENABLE_ROADBLOCKS then
					roadblocks_enable(true)
					sandbox_message("Roadblocks enabled")
				else
					roadblocks_enable(false)
					sandbox_message("Roadblocks disabled")
				end
				SPP_ENABLE_ROADBLOCKS = not SPP_ENABLE_ROADBLOCKS
				reset_input_sequence()
			elseif codestring == "826" then
				if not SPP_PED_BUMS then
					spawn_override_set_category("SH - UGCaverns - Bums")
					sandbox_message("Bum pedestrians enabled")
				else
					spawn_override_set_category("")
					sandbox_message("Bum pedestrians disabled")
				end
				SPP_PED_BUMS = not SPP_PED_BUMS
				reset_input_sequence()
			elseif codestring == "827" then
				if not SPP_ENABLE_BOATS then
					spawning_boats(true)
					sandbox_message("Boat spawning enabled")
				else
					spawning_boats(false)
					sandbox_message("Boat spawning disabled")
				end
				SPP_ENABLE_BOATS = not SPP_ENABLE_BOATS
				reset_input_sequence()
			elseif codestring == "828" then
				-- CD Finder
				local sync = SYNC_LOCAL	-- Which player is affected
				if COOP_COMMANDS_ACTIVE then
					sync = SYNC_ALL
				end

				local ingame_effect = ""	-- Ingame Effect
				if SPP_OPTIONS_SHOW_LIGHTCONE_FOR_CD_FINDER then
					ingame_effect = INGAME_EFFECT_LOCATION
				end

				for i = 1, 50, 1 do
					local cd_navpoint_name	-- CD Navpoint Name
					if i >= 10 then
						cd_navpoint_name = "cds_sr2_city_"..i
					else
						cd_navpoint_name = "cds_sr2_city_0"..i	-- Append 0 in front of the number in 0-9
					end

					if SPP_CD_FINDER then
						marker_remove_navpoint(cd_navpoint_name, SYNC_ALL)
					else
						marker_add_navpoint(cd_navpoint_name, MINIMAP_ICON_LOCATION, ingame_effect, sync)
					end
				end

				if SPP_CD_FINDER then
					sandbox_message("CD locations removed from the map", sync)
				else
					sandbox_message("CD locations added to the map", sync)
				end

				SPP_CD_FINDER = not SPP_CD_FINDER
				reset_input_sequence()
			elseif codestring == "831" then
				if not SPP_HEALTH_REGEN then
					character_dont_regenerate(LOCAL_PLAYER, false)
					if COOP_COMMANDS_ACTIVE then
						character_dont_regenerate(REMOTE_PLAYER, false)
					end
					sandbox_message("Health regeneration enabled")
				else
					character_dont_regenerate(LOCAL_PLAYER, true)
					if COOP_COMMANDS_ACTIVE then
						character_dont_regenerate(REMOTE_PLAYER, true)
					end
					sandbox_message("Health regeneration disabled")
				end
				SPP_HEALTH_REGEN = not SPP_HEALTH_REGEN
				reset_input_sequence()
			elseif codestring == "832" then
				if Spp_stink_thread_handle == INVALID_THREAD_HANDLE then
					Spp_stink_thread_handle = thread_new("spp_stink_thread")	-- Peds run away thread
					sandbox_message("Pedestrians Run Away enabled")
				else
					thread_kill(Spp_stink_thread_handle)
					Spp_stink_thread_handle = INVALID_THREAD_HANDLE
					sandbox_message("Pedestrians Run Away disabled")
				end
				reset_input_sequence()
			elseif codestring == "833" then
				if not SPP_FORCE_PASSENGER_SEAT then
					player_force_vehicle_seat(LOCAL_PLAYER, 1)
					if COOP_COMMANDS_ACTIVE then
						player_force_vehicle_seat(REMOTE_PLAYER, 2)
					end
					sandbox_message("Force Passenger Seat enabled")
				else
					player_force_vehicle_seat(LOCAL_PLAYER, -1)
					if COOP_COMMANDS_ACTIVE then
						player_force_vehicle_seat(REMOTE_PLAYER, -1)
					end
					sandbox_message("Force Passenger Seat disabled")
				end
				SPP_FORCE_PASSENGER_SEAT = not SPP_FORCE_PASSENGER_SEAT
				reset_input_sequence()
			elseif codestring == "834" then
				if not character_hidden(LOCAL_PLAYER) then
					character_hide(LOCAL_PLAYER)
					if COOP_COMMANDS_ACTIVE then
						character_hide(REMOTE_PLAYER)
					end
					sandbox_message("Player hidden")
				else
					character_show(LOCAL_PLAYER)
					if COOP_COMMANDS_ACTIVE then
						character_show(REMOTE_PLAYER)
					end
					sandbox_message("Player unhide")
				end
				reset_input_sequence()
			elseif codestring == "835" then
				if SPP_INVERTED_SONG_OF_TIME == 0 then
					set_time_of_day_scale(0)
					sandbox_message("Time Speed: 0")
					SPP_INVERTED_SONG_OF_TIME = 1
				elseif SPP_INVERTED_SONG_OF_TIME == 1 then
					set_time_of_day_scale(50)
					sandbox_message("Time Speed: 50")
					SPP_INVERTED_SONG_OF_TIME = 2
				elseif SPP_INVERTED_SONG_OF_TIME == 2 then
					set_time_of_day_scale()
					sandbox_message("Time Speed: 100")
					SPP_INVERTED_SONG_OF_TIME = 3
				elseif SPP_INVERTED_SONG_OF_TIME == 3 then
					set_time_of_day_scale(200)
					sandbox_message("Time Speed: 200")
					SPP_INVERTED_SONG_OF_TIME = 4
				elseif SPP_INVERTED_SONG_OF_TIME == 4 then
					set_time_of_day_scale(500)
					sandbox_message("Time Speed: 500")
					SPP_INVERTED_SONG_OF_TIME = 5
				elseif SPP_INVERTED_SONG_OF_TIME == 5 then
					set_time_of_day_scale(1000)
					sandbox_message("Time Speed: 1000")
					SPP_INVERTED_SONG_OF_TIME = 6
				elseif SPP_INVERTED_SONG_OF_TIME == 6 then
					set_time_of_day_scale(5000)
					sandbox_message("Time Speed: 5000")
					SPP_INVERTED_SONG_OF_TIME = 7
				elseif SPP_INVERTED_SONG_OF_TIME == 7 then
					set_time_of_day_scale(10000)
					sandbox_message("Time Speed: 10000")
					SPP_INVERTED_SONG_OF_TIME = 8
				elseif SPP_INVERTED_SONG_OF_TIME == 8 then
					set_time_of_day_scale(100000)
					sandbox_message("Time Speed: 100000")
					SPP_INVERTED_SONG_OF_TIME = 0
				end
				reset_input_sequence()
			elseif codestring == "836" then
				set_time_of_day(SPP_HOUR, 0)
				sandbox_message("Hour set to: "..tostring(SPP_HOUR))
				SPP_HOUR = SPP_HOUR + 1
				if SPP_HOUR >= 24 then
					SPP_HOUR = 0
				end
				reset_input_sequence()
			elseif codestring == "837" then
				if SPP_WEATHER == 0 then
					set_weather(0, true)
					sandbox_message("Set Weather: Clear Skies")
					SPP_WEATHER = 1
				elseif SPP_WEATHER == 1 then
					set_weather(1, true)
					sandbox_message("Set Weather: Partly Cloudy")
					SPP_WEATHER = 2
				elseif SPP_WEATHER == 2 then
					set_weather(2, true)
					sandbox_message("Set Weather: Light Rain")
					SPP_WEATHER = 3
				elseif SPP_WEATHER == 3 then
					set_weather(3, true)
					sandbox_message("Set Weather: Overcast")
					SPP_WEATHER = 4
				elseif SPP_WEATHER == 4 then
					set_weather(4, true)
					sandbox_message("Set Weather: Pre-Storm")
					SPP_WEATHER = 5
				elseif SPP_WEATHER == 5 then
					set_weather(5, true)
					sandbox_message("Set Weather: Thunderstorm")
					SPP_WEATHER = 6
				elseif SPP_WEATHER == 6 then
					set_weather(6, true)
					sandbox_message("Set Weather: Post-Storm")
					SPP_WEATHER = 7
				elseif SPP_WEATHER == 7 then
					set_weather(7, true)
					sandbox_message("Set Weather: Vibrant")
					SPP_WEATHER = 8
				elseif SPP_WEATHER == 8 then
					set_weather(-1)
					sandbox_message("Set Weather: Weather Lock Cleared")
					SPP_WEATHER = 0
				end
				reset_input_sequence()
			elseif codestring == "838" then
				if SPP_RAGDOLL then
					character_allow_ragdoll(LOCAL_PLAYER, false)
					if COOP_COMMANDS_ACTIVE then
						character_allow_ragdoll(REMOTE_PLAYER, false)
					end
					sandbox_message("Player Ragdoll Disabled")
					SPP_RAGDOLL = false
				else
					character_allow_ragdoll(LOCAL_PLAYER, true)
					if COOP_COMMANDS_ACTIVE then
						character_allow_ragdoll(REMOTE_PLAYER, true)
					end
					sandbox_message("Player Ragdoll Enabled")
					SPP_RAGDOLL = true
				end
				reset_input_sequence()
			elseif codestring == "841" then
				character_evacuate_from_all_vehicles(LOCAL_PLAYER)
				if COOP_COMMANDS_ACTIVE then
					character_evacuate_from_all_vehicles(REMOTE_PLAYER)
				end
				sandbox_message("Player evacuate from a vehicle")
				reset_input_sequence()
			elseif codestring == "842" then
				if SPP_VEHICLE_ENTER_EXIT then
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, false)
					if COOP_COMMANDS_ACTIVE then
						set_player_can_enter_exit_vehicles(REMOTE_PLAYER, false)
					end
					sandbox_message("Vehicle Enter/Exit Disabled")
					SPP_VEHICLE_ENTER_EXIT = false
				else
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)
					if COOP_COMMANDS_ACTIVE then
						set_player_can_enter_exit_vehicles(REMOTE_PLAYER, true)
					end
					sandbox_message("Vehicle Enter/Exit Enabled")
					SPP_VEHICLE_ENTER_EXIT = true
				end
				reset_input_sequence()
			elseif codestring == "843" then
				local player_vehicle, partner_vehicle = spp_get_player_vehicle_names()
				if player_vehicle ~= "" then
					vehicle_infinite_mass(player_vehicle, SPP_VEHICLE_INFINITE_MASS)
				end
				if partner_vehicle ~= "" then
					vehicle_infinite_mass(partner_vehicle, SPP_VEHICLE_INFINITE_MASS)
				end
				if (player_vehicle ~= "") or (partner_vehicle ~= "") then
					if SPP_VEHICLE_INFINITE_MASS then
						sandbox_message("Vehicle Infinite Mass Enabled")
					else
						sandbox_message("Vehicle Infinite Mass Disabled")
					end
					SPP_VEHICLE_INFINITE_MASS = not SPP_VEHICLE_INFINITE_MASS
				else
					sandbox_message("Vehicle Infinite Mass: Player is not in a vehicle")
				end
				reset_input_sequence()
			elseif codestring == "844" then
				local player_vehicle, partner_vehicle = spp_get_player_vehicle_names()
				if player_vehicle ~= "" then
					local smoking, fire = vehicle_get_smoke_and_fire_state(player_vehicle)
					vehicle_set_smoke_and_fire_state(player_vehicle, (not smoking), fire)
				end
				if partner_vehicle ~= "" then
					local smoking, fire = vehicle_get_smoke_and_fire_state(partner_vehicle)
					vehicle_set_smoke_and_fire_state(partner_vehicle, (not smoking), fire)
				end
				if Spp_auto_repair_thread_handle ~= INVALID_THREAD_HANDLE then
					sandbox_message("Vehicle Smoke is not usable when Auto Repair is active")
				elseif (player_vehicle ~= "") or (partner_vehicle ~= "") then
					sandbox_message("Vehicle Smoke Toggled")
				else
					sandbox_message("Vehicle Smoke: Player is not in a vehicle")
				end
				reset_input_sequence()
			elseif codestring == "845" then
				local player_vehicle, partner_vehicle = spp_get_player_vehicle_names()
				if player_vehicle ~= "" then
					local smoking, fire = vehicle_get_smoke_and_fire_state(player_vehicle)
					vehicle_set_smoke_and_fire_state(player_vehicle, smoking, (not fire))
				end
				if partner_vehicle ~= "" then
					local smoking, fire = vehicle_get_smoke_and_fire_state(partner_vehicle)
					vehicle_set_smoke_and_fire_state(partner_vehicle, smoking, (not fire))
				end
				if Spp_auto_repair_thread_handle ~= INVALID_THREAD_HANDLE then
					sandbox_message("Vehicle Fire is not usable when Auto Repair is active")
				elseif (player_vehicle ~= "") or (partner_vehicle ~= "") then
					sandbox_message("Vehicle Fire Toggled")
				else
					sandbox_message("Vehicle Fire: Player is not in a vehicle")
				end
				reset_input_sequence()
			elseif codestring == "846" then
				local player_vehicle, partner_vehicle = spp_get_player_vehicle_names()
				if player_vehicle ~= "" then
					vehicle_suppress_flipping(player_vehicle, SPP_VEHICLE_SUPPRESS_FLIPPING)
				end
				if partner_vehicle ~= "" then
					vehicle_suppress_flipping(partner_vehicle, SPP_VEHICLE_SUPPRESS_FLIPPING)
				end
				if (player_vehicle ~= "") or (partner_vehicle ~= "") then
					if SPP_VEHICLE_SUPPRESS_FLIPPING then
						sandbox_message("Vehicle Suppress Flipping Enabled")
					else
						sandbox_message("Vehicle Suppress Flipping Disabled")
					end
					SPP_VEHICLE_SUPPRESS_FLIPPING = not SPP_VEHICLE_SUPPRESS_FLIPPING
				else
					sandbox_message("Vehicle Suppress Flipping: Player is not in a vehicle")
				end
				reset_input_sequence()
			elseif codestring == "847" then
				if Spp_auto_repair_thread_handle == INVALID_THREAD_HANDLE then
					Spp_auto_repair_thread_handle = thread_new("spp_auto_repair_thread")	-- Auto repair thread
					sandbox_message("Vehicle Auto Repair enabled")
				else
					thread_kill(Spp_auto_repair_thread_handle)
					Spp_auto_repair_thread_handle = INVALID_THREAD_HANDLE
					sandbox_message("Vehicle Auto Repair disabled")
				end
				reset_input_sequence()
			elseif codestring == "848" then
				-- interior = true, blocking = true, temporary = false
				if SPP_PHILLIPS_BUILDING then
					city_chunk_swap("SR2_IntSRMisPhiltwr", "blowup", true, true, false)
					sandbox_message("Phillips Building changed to blowup")
				else
					city_chunk_swap("SR2_IntSRMisPhiltwr", "normal", true, true, false)
					sandbox_message("Phillips Building changed to normal")
				end
				SPP_PHILLIPS_BUILDING = not SPP_PHILLIPS_BUILDING
				reset_input_sequence()

			elseif codestring == "883" then
				spp_teleport("act_al_navs_fight_ar_center", "Fight Club Arena Inside Ring")
				reset_input_sequence()
			elseif codestring == "884" then
				spp_teleport("exploration_chunk542", "Super Secret Island")
				reset_input_sequence()
			elseif codestring == "885" then
				spp_teleport("cribs_sr2_city_$PB_arena_out", "Ultor Arena")
				reset_input_sequence()
			elseif codestring == "886" then
				spp_teleport("cribs_sr2_city_$PB_tohoku_out", "Tohoku Hotel")
				reset_input_sequence()
			elseif codestring == "887" then
				spp_teleport("cribs_sr2_city_$PB_gym_out", "Gymnasium")
				reset_input_sequence()
			elseif codestring == "888" then
				if SANDBOX_MESSAGES then
					mission_help_clear(SYNC_LOCAL)
					mission_help_table_nag("LAST CODE ENTERED: "..Spp_last_command_code.."\n"..Spp_last_command_text, "", "", SYNC_LOCAL)
				end
				reset_input_sequence()
			else
				if SANDBOX_MESSAGES then
					mission_help_clear(SYNC_LOCAL)
					mission_help_table_nag("CODE ENTRY: "..codestring.."\nFAILED", "", "", SYNC_LOCAL)
				end
				reset_input_sequence()
			end
		end

		thread_yield()
	end
end

function clear_other_gang_notoriety(current_gang)
	notoriety_set_min("Samedi", 0)
	notoriety_set_max("Samedi", 5)
	notoriety_set("Samedi",0)
	notoriety_set_min("Ronin", 0)
	notoriety_set_max("Ronin", 5)
	notoriety_set("Ronin",0)
	notoriety_set_min("Brotherhood", 0)
	notoriety_set_max("Brotherhood", 5)
	notoriety_set("Brotherhood",0)
end

function remove_all_notoriety_locks()
	notoriety_set_min("Police", 0)
	notoriety_set_max("Police", 5)
	notoriety_set_min("Samedi", 0)
	notoriety_set_max("Samedi", 5)
	notoriety_set_min("Ronin", 0)
	notoriety_set_max("Ronin", 5)
	notoriety_set_min("Brotherhood", 0)
	notoriety_set_max("Brotherhood", 5)
end

function clear_all_notoriety()
	notoriety_set("Police", 0)
	notoriety_set("Samedi", 0)
	notoriety_set("Ronin", 0)
	notoriety_set("Brotherhood", 0)
end

function load_chunky()
	city_chunk_swap("sr2_chunk111", "yacht", false, true, false)
	city_chunk_swap("sr2_intsrmisyacht01empty", "yacht", true, true, false)
	debug_print("Gentlemen of the Row 1.9 Loaded \n")
	
	-- Repair Phillips Building after purchased [nclok1405] 
	if crib_is_unlocked("Ultor_Phillips") then
		city_chunk_swap("SR2_IntSRMisPhiltwr", "normal", true, true, false)
		debug_print("Phillips Building changed to normal because you bought its crib")
	end
end

function sr2_city_init()
	debug_print("sr2_city_init() called")
-- DISTRICTS
	airport_init()
	apartments_init()
	arena_init()
	barrio_init()
	chinatown_init()
	docks_init()
	downtown_init()
	factories_init()
	highend_init()
	hotels_init()
	museum_init()
	nuke_init()
	prison_init()
	projects_init()
	redlight_init()
	saintsrow_init()
	suburbs_init()
	subexp_init()
	trailerpark_init()
	truckyard_init()
	ultor_base_init()
	underground_init()
	university_init()

-- MISSIONS
	mission_globals_init()

-- STRONGHOLDS
	stronghold_globals_init()

end

function sr2_city_main()
	debug_print("sr2_city_main() called")
-- DISTRICTS
	thread_new("airport_main")
	thread_new("apartments_main")
	thread_new("arena_main")
	thread_new("barrio_main")
	thread_new("chinatown_main")
	thread_new("docks_main")
	thread_new("downtown_main")
	thread_new("factories_main")
	thread_new("highend_main")
	thread_new("hotels_main")
	thread_new("museum_main")
	thread_new("nuke_main")
	thread_new("prison_main")
	thread_new("projects_main")
	thread_new("redlight_main")
	thread_new("saintsrow_main")
	thread_new("suburbs_main")
	thread_new("subexp_main")
	thread_new("trailerpark_main")
	thread_new("truckyard_main")
	thread_new("ultor_base_main")
	thread_new("underground_main")
	thread_new("university_main")

-- MISSIONS
	thread_new("tss01_main")	-- Third Street Saints (Prologue)
	thread_new("tss02_main")
	thread_new("tss03_main")
	thread_new("tss04_main")

	thread_new("bh01_main")		-- The Brotherhood
	thread_new("bh02_main")
	thread_new("bh03_main")
	thread_new("bh04_main")
	thread_new("bh05_main")
	thread_new("bh06_main")
	thread_new("bh07_main")
	thread_new("bh08_main")
	thread_new("bh09_main")
	thread_new("bh10_main")
	thread_new("bh11_main")

	thread_new("rn01_main")		-- The Ronin
	thread_new("rn02_main")
	thread_new("rn03_main")
	thread_new("rn04_main")
	thread_new("rn05_main")
	thread_new("rn06_main")
	thread_new("rn07_main")
	thread_new("rn08_main")
	thread_new("rn09_main")
	thread_new("rn10_main")
	thread_new("rn11_main")

	thread_new("ss01_main")		-- Sons of Samedi
	thread_new("ss02_main")
	thread_new("ss03_main")
	thread_new("ss04_main")
	thread_new("ss05_main")
	thread_new("ss06_main")
	thread_new("ss07_main")
	thread_new("ss08_main")
	thread_new("ss09_main")
	thread_new("ss10_main")
	thread_new("ss11_main")

	thread_new("ep01_main")		-- Epilogue Missions
	thread_new("ep02_main")
	thread_new("ep03_main")
	thread_new("ep04_main")

	thread_new("em01_main")		-- Emergent Missions
	thread_new("em02_main")

	thread_new("dlc04_main")	-- Custom Missions
	thread_new("dlc05_main")

-- STRONGHOLDS ???????


	load_chunky() -- Loads yacht chunks for crib
	Keycombo_Handle = thread_new("keycombo_thread") -- Sandbox+ thread
	
	-- Cop driveby [nclok1405]
	SPP_COP_DRIVEBY = SPP_OPTIONS_COP_DRIVEBY
	if SPP_COP_DRIVEBY then
		set_cops_shooting_from_vehicles(true)
		debug_print("Cop drive-by enabled by default on sr2_city.lua")
	end
end
